(function() {

    var app = angular.module('FuelIoc');

    var EBill = function($http) {

        var Bills = null;
        var areEBillsLoaded = false;

        var AreEBillsLoaded = function() {
            return areEBillsLoaded;
        }
        var Ebills = function()
        {
            return Bills;
        }
        
        var getEBills = function(userId, successCallBack, errorCallBack) {
            $http.get("https://xsparsh.indianoil.in:8443/soa-infra/resources/default/RDBFuel/RSMyBill",
                {
                    params: {
                        user_id: userId
                    }
                }).success(function(data, status) {
                    if (data && data.BilleBankFinalOutput && data.BilleBankFinalOutput.length > 0) {
                        for (i = 0; i < data.BilleBankFinalOutput.length; i++) {
                            var dt = new Date(data.BilleBankFinalOutput[i].UPDATE_DATETIME.toString());
                            data.BilleBankFinalOutput[i].Date = dt.toDateString();
                            data.BilleBankFinalOutput[i].Time = dt.getHours().toString() + ' : ' + dt.getMinutes().toString();

                            if (data.BilleBankFinalOutput[i].PRODUCT === "Diese" || data.BilleBankFinalOutput[i].PRODUCT === "DIESE" || data.BilleBankFinalOutput[i].PRODUCT === "HSD") {
                                data.BilleBankFinalOutput[i].PRODUCT = "Diesel";
                            } else if (data.BilleBankFinalOutput[i].PRODUCT === "Petrol" || data.BilleBankFinalOutput[i].PRODUCT === "PETROL" || data.BilleBankFinalOutput[i].PRODUCT === "MS") {
                                data.BilleBankFinalOutput[i].PRODUCT = "Petrol";
                            }
                        }
                        Bills = sortEbills(data.BilleBankFinalOutput,'UPDATE_DATETIME');
                        if(successCallBack)
                        {
                             successCallBack(Bills);
                        }
                    }
                    else {
                        if(errorCallBack)
                        {
                            errorCallBack('No Data Found');
                        }
                        
                    }
                    areEBillsLoaded = false;
                }).error(onError);
                
                function onError()
                {
                    errorCallBack('Sorry for the inconvenience. Small problem occured while accessing service');
                }
        }
        function sortEbills(bills, key) {
            return bills.sort(function(a, b) {
                var x = a[key];
                var y = b[key];
                return ((x > y) ? -1 : ((x < y) ? 1 : 0));
            });
        }
        
        return {
            getEBills: getEBills,
            AreEBillsLoaded: AreEBillsLoaded,
            Ebills:Ebills
        }
    };
    app.factory("eBillService", EBill);
} ());
