(function() {

    var app = angular.module('FuelIoc');

    var LoginController = function($scope, userService, $ionicPopup, $http, $ionicLoading, $state, $cordovaSms, $timeout,  $cordovaDatePicker, eBillService, AppVersionMgmt) {

        var username, password;
        $scope.lgStatus = false;
        $scope.name = '';
        $scope.stage = 1;
        var isFirst = true;

        $ionicLoading.show({
            template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Loading!'
        });
        userService.setUser(null);

        $scope.goBack = function(view) {
            $state.go('login');
        }
        $scope.$on('$ionicView.enter', function() {
           
            
            AppVersionMgmt.checkVersionUpdate(callBk);
            //callBk();
            function callBk() {
                username = window.localStorage.getItem('username');
                password = window.localStorage.getItem('password');

                if (username != null && password != null && username != '' && password != null) {
                    userService.loginUser(username, password).then(function(data) {

                        if (data != null) {
                            userService.setUser(data);
                            $ionicLoading.hide();
                            $state.go('app.home');
                            
                            userService.populateRtdRos(data.FaiUserProfile[0].mobile);
                            eBillService.getEBills(data.FaiUserProfile[0].userId, $scope.checkEbillRateRo, onErrorCallBack);

                            function onErrorCallBack(data) {
                                //alert('error coured');
                            }
                        } else {
                            $scope.user.username = "";
                            $scope.user.password = "";
                            $scope.lgStatus = true;

                            if (userService.getIsFirst()) {
                                var alertPopup = $ionicPopup.alert({
                                    title: '<span style="color:#10224d">Welcome</span>',
                                    template: " We have changed our login process. Kindly enter your registered mobile no & password for login.<br><br>  If you don't remember your password use <span style='color:red;'>'Forgot Password'</span> option to get your password as SMS"
                                });
                                userService.setIsFirst();
                            }
                        }
                    });
                }
                else {
                    if (userService.getIsFirst()) {
                        var alertPopup = $ionicPopup.alert({
                            title: '<span style="color:#10224d">Welcome</span>',
                            template: " We have changed our login process. Kindly enter your registered mobile no & password for login.<br><br> If you don't remember your password use <span style='color:red;'>'Forgot Password'</span> option to get your password as SMS"
                        });
                        userService.setIsFirst();
                    }

                    $scope.lgStatus = true;
                }

            }
            
            
        });


        $ionicLoading.hide();

        $scope.user = { username: "", password: "", cpassword: "", mobile: "", otp: 0, rotp: 1234, email: "", name: "", vehicle: "" };
        $scope.signIn = function(user) {
           
           $ionicLoading.show({
                            template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
                        });
           signInUser(user);
           

        };
        
        function signInUser(user)
        {
            var isError = false;
            if (user.username != null && user.username.length < 1) {
                isError = true;
                var alertPopup = $ionicPopup.alert({
                    title: 'Login Error',
                    template: 'Blank username'
                });
                $ionicLoading.hide();
            }
            if (isError == false && user.password != null && user.password.length < 1) {
                isError = true;
                var alertPopup = $ionicPopup.alert({
                    title: 'Login Error',
                    template: 'Blank password'
                });
                $ionicLoading.hide();
            }
            
            if (!isError) {
                
                userService.loginUser(user.username, user.password).then(function(data) {
                   
                    if (data != null) {
                        userService.populateRtdRos(data.FaiUserProfile[0].mobile);
                        eBillService.getEBills(data.FaiUserProfile[0].userId, $scope.checkEbillRateRo, onErrorCallBack);
                        function onErrorCallBack(data) {
                                    //alert('error coured');
                        }
                        window.localStorage.setItem('username', user.username);
                        window.localStorage.setItem('password', user.password);
                        
                        userService.setUser(data);
                            $ionicLoading.hide();
                            $state.go('app.home');
                    } else {
                        $ionicLoading.hide();
                        var alertPopup = $ionicPopup.alert({
                            title: 'Login Error',
                            template: 'Invalid username/password'
                        });
                        $scope.user.username = "";
                        $scope.user.password = "";
                    }
                });
                

            }
        }
        
        $scope.newUser = function() {
            $state.go('register');
        };

        $scope.error = "";
        
        $scope.createUser = function(user)
        {
            var isError = false;
            if(!isError)
            {
                isError = false;
                $ionicLoading.show({
                    template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing!'
                });
                userService.createUser(user,callBack); 
                $ionicLoading.hide();
            }
            function callBack(response)
            {
                if (response == 200 || response == 204) {
                       window.localStorage.setItem('username', user.mobile);
                       window.localStorage.setItem('password', user.password);
                       $ionicLoading.hide();
                       $scope.stage = 3;
                       $scope.error ="";
                   } else {
                       $scope.error = "Internal Server Error";
                   }
            }
        }
        
     
        $scope.validateFirstStage = function(user,vehicle) {
            var isError = false;
            var OTP = createOTP();
            $scope.user.gender = "Gender";
            $scope.user.otp = "";
            //var OTP = 4444;
            //alert(OTP);
            var msg = 'The OTP for creating account is ' + OTP;
            
            if (user.name == null || user.name.length < 1) {
                isError = true;
                $scope.error = "Name is required";
                return;
            }
            if (user.mobile == null || user.mobile.length < 10) {
                isError = true;
                $scope.error = "Invalid/blank mobile no.";
                return;
            }
            if (user.email == null || user.email.length < 1) {
                isError = true;
                $scope.error = "Email is required";
                return;
            }
            if (vehicle.regNo == null || vehicle.regNo < 1) {
                $scope.error = "Enter vehicle registration number";
                isError = true;
                return;
            }
            if (user.password == null || user.password.length < 1) {
                isError = true;
                $scope.error = "Password is required";
                return;
            }
            if (user.cpassword == null || user.cpassword.length < 1) {
                isError = true;
                $scope.error = "Password is required";
                return;
            }
            if (user.password != user.cpassword) {
                isError = true;
                $scope.error = "Password did not match";
                $scope.user.password = "";
                $scope.user.cpassword = "";
                return;
            }

            if (!isError) {
                $ionicLoading.show({
                    template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing!'
                });
                userService.isUserExist(user.email, user.mobile).then(function(exists) {
                    if (exists) {
                        $scope.error = "Email ID / Mobile no. is already registered. You may Login directly through main screen.  If you don't remember your password use 'Forgot Password' option.";
                        $ionicLoading.hide();
                        return false;
                    } else {
                        
                        $scope.error = "";
                        
                      
                        var msg = 'Thanks for downloading Fuel@IOC App. Your OTP for mobile number validation is ' + OTP;
                        /*
                        var content={
                                                "mobile_no" : user.mobile,
                                                "sms_content" : msg,
                                                "sms_type" : "ENG",
                                                "userID" : "WEBS",
                                                "password" : "WEBS@USER765"
        
                                };
                           */     
                        var content = {
                            "mobile_no": user.mobile,
                            "sms_text": msg,
                            "user_id": "FUEL@IOC",
                            "password": "FUEL@IOC123",
                            "app_name": "Otp_FuelAIOC",   /// Swachh, OTP, feedback etc.
                            "dealer_code": 0 /// pass 0 if not available in case of OTP, general feedback etc.
                        };
                        
                        $http.post("https://xsparsh.indianoil.in:8443/soa-infra/resources/default/RDBFuel/RSSendSMSv2/", content)
                        .success(function(data, status) 
                        {
                                        $ionicLoading.hide();
                                        var myPopup = $ionicPopup.show({
                                        template: '<span style="color:#10224d">Please enter the OTP that has been sent to your mobile number <span style="color: black;font-weight:bold">'+user.mobile +'</span></span><br><br><p style="color: red;">{{error}}</p><input type="number" placeholder="Enter OTP" ng-model="user.otp">',
                                        title: '<span>User Registration</span>',
                                        scope: $scope,

                                        buttons: [
                                                    { text: 'Cancel',
                                                      type: 'button-assertive'
                                                    },
                                                    {
                                                        text: '<b>OTP</b>',
                                                        type: 'button-positive',
                                                        onTap: function(e) {
                                                            if ($scope.user.otp != null) {
                                                                    if ($scope.user.otp == OTP) {
                                                                        $ionicLoading.show({
                                                                            template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Loading!'
                                                                        });
                                                                        
                                                                        userService.createUser(user,callBack); 

                                                                        function callBack(status,data) {
                                                                            if (status == 200 || status == 204) {
                                                                                
                                                                                window.localStorage.setItem('username', user.mobile);
                                                                                window.localStorage.setItem('password', user.password);
                                                                                
                                                                                
                                                                                //alert(data.FaiUserProfile[0].userId);
                                                                                var content = {
                                                                                    FaiUserVehicle: [
                                                                                        {
                                                                                            userId: data.FaiUserProfile[0].userId,
                                                                                            vehicleId: "",
                                                                                            vehicleType: "",
                                                                                            vehicleMake: "",
                                                                                            vehicleModel: "",
                                                                                            regNo: vehicle.regNo.replace(/ /g, '').toUpperCase(),
                                                                                            fuelType: "",
                                                                                            fuelCapacity: "",
                                                                                            puc: "",
                                                                                            insurance: "",
                                                                                            tax: ""
                                                                                        }
                                                                                    ]

                                                                                };

                                                                                $http.post("https://xsparsh.indianoil.in:8443/soa-infra/resources/default/RDBFuel/RSUVAdd/", content)
                                                                                    .success(function(data, status) {
                                                                                        if (status == "204") {
                                                                                            $ionicLoading.hide();
                                                                                            $state.go("app.home");
                                                                                        }
                                                                                        else {
                                                                                            $state.go("app.home");
                                                                                        }
                                                                                        $timeout(function() {
                                                                                            $ionicLoading.hide();
                                                                                        }, 1000);
                                                                                    }).error(function(data) {
                                                                                        $state.go("app.home");
                                                                                    });

                                                                                $ionicLoading.hide();
                                                                                
                                                                            } else {
                                                                                $scope.error = "Internal Server Error Occured";
                                                                            }
                                                                        }

                                                                    } else {
                                                                            $scope.error = "Invalid Otp";
                                                                            e.preventDefault();
                                                                            $ionicLoading.hide();
                                                                    }
                                                            } else {
                                                                        e.preventDefault();
                                                            }
                                                            
                                                    }
                                                }
                                            ]
                                    });
                            }).error(function(data) 
                            {
                                   alert('Error occured while sending sms');
                            });
                    } 
                    
                });
            }
        };

        $scope.forgotPass = function() {

           
            var OTP = createOTP();
            //var OTP = 4444;
            //alert(OTP);
            var msg = 'Thanks for downloading Fuel@IOC. Your password has been successfully reset to ' + OTP+' for login';
            
            //alert(msg);
            var myPopup = $ionicPopup.show({
                template: '<input type="number" ng-model="user.mobile" placeholder="Enter Mobile No.">',
                title: 'Forgot Password',
                scope: $scope,
                buttons: [
                    { text: 'Cancel',
                      type: 'button-assertive'
                    },
                    {
                        text: '<b>Send OTP</b>',
                        type: 'button-positive',
                        onTap: function(e) {
                            
                            if ($scope.user.mobile != null && $scope.user.mobile.length < 10) {
                                
                                
                                var alertPopup = $ionicPopup.alert({
                                    title: 'Alert',
                                    template: 'Invalid/Blank Mobile number'
                                });
                                
                            } else {
                                //alert('entered');
                                $ionicLoading.show({
                                    template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Sending OTP'
                                });
                               /* 
                                var content={
                                                "mobile_no" : $scope.user.mobile,
                                                "sms_content" : msg,
                                                "sms_type" : "ENG",
                                                "userID" : "WEBS",
                                                "password" : "WEBS@USER765"
                                };
                                */
                                var content = {
                                    "mobile_no": $scope.user.mobile,
                                    "sms_text": msg,
                                    "user_id": "FUEL@IOC",
                                    "password": "FUEL@IOC123",
                                    "app_name": "Otp_FuelAIOC",   /// Swachh, OTP, feedback etc.
                                    "dealer_code": 0 /// pass 0 if not available in case of OTP, general feedback etc.
                                };
                                userService.isUserExist("", $scope.user.mobile).then(function(exists) 
                                {
                                    if (!exists) {
                                      
                                      var alertPopup = $ionicPopup.alert({
                                                title: 'Hi',
                                                template:"Your mobile no <span style = 'font-weight:bold;color:red'>"+ $scope.user.mobile+ "</span> is not registered with us. <br>Go for <span  style = 'font-weight:bold;color:red'><a ng-click='newUser()'>Create now</a></span> option" 
                                       });
                                      $ionicLoading.hide();
                                    }
                                    else
                                    {
                                        $http.post("https://xsparsh.indianoil.in:8443/soa-infra/resources/default/RDBFuel/RSSendSMSv2/", content)
                                        .success(function(data, status) 
                                        {
                                                var URL="https://xsparsh.indianoil.in:8443/soa-infra/resources/default/RDBFuel/RSResetPass/?mobile="+$scope.user.mobile+"&pass="+OTP;
                                                $http.post(URL,"")
                                                    .success(function(data, status) {
                                                        var alertPopup = $ionicPopup.alert({
                                                            title: 'Hi',
                                                            template: 'Password sent to your mobile number use it for login.'
                                                        });
                                                        $ionicLoading.hide();
                                                    }).error(function(data) {
                                                        alert('Error occured while resetting password');
                                                    });
                                          }).error(function(data) {
                                                alert('Error occured while sending sms');
                                                $ionicLoading.hide();
                                         });
                                    }
                                    
                                    
                                });
                                
                                
                                /*var options = {
                                    replaceLineBreaks: false, // true to replace \n by a new line, false by default
                                    android: {
                                        intent: '' // send SMS with the native android SMS messaging
                                        //intent: '' // send SMS without open any other app
                                        //intent: 'INTENT' // send SMS inside a default SMS app
                                    }
                                };
                                $cordovaSms
                                    .send($scope.user.mobile, msg, options)
                                    .then(function() {
                                        $ionicLoading.hide();
                                        var validateOtpPopup = $ionicPopup.show({
                                            template: '<input type="number" ng-model="user.otpU">',
                                            title: 'OTP Verification',
                                            subTitle: 'Enter One Time Password',
                                            scope: $scope,
                                            buttons: [
                                                { text: 'Cancel' },
                                                {
                                                    text: '<b>submit</b>',
                                                    type: 'button-positive',
                                                    onTap: function(e) {
                                                        if ($scope.user.otpU == OTP) {
                                                            //alert('Sucessfully validated');
                                                            $state.go('rstPassword');
                                                        }
                                                        else {
                                                            var alertPopup = $ionicPopup.alert({
                                                                title: 'Invlaid OTP',
                                                                template: 'OTP validation failed'
                                                            });
                                                        }
                                                        
                                                    }
                                                }
                                            ]
                                        });
                                    }, function(error) {
                                        alert(error.message);
                                        // An error occurred
                                         $ionicLoading.hide();
                                    });*/
                            }
                        }
                    }
                ]
            });
        };
        
        $scope.vechicle = {
            regNo: ""
        };
                  
        function createOTP() {
            var num = 00;
            while (num.toString().length != 5) {
                num = Math.random() * 100000;
                num = Math.floor(num);
            }

            return num;
        }
        
        $scope.checkEbillRateRo = function(data)
        {
           if(data[0].is_rated==0)
           {
               var confirmPopup = $ionicPopup.confirm({
                                 title: 'Rate Fuel Station',
                                 template: '<span style="color:#10224d">Recently you bought fuel from <span style="color: black;font-weight:bold">'+data[0].CUST_NAME +'.</span><br><span>Please rate the fuel station.</span>',
                                 buttons: [
                                                {
                                                    text: '<b>Rate</b>',
                                                    type: 'button-positive',
                                                    onTap: function(e) {
                                                        userService.setMapView('RatingRo');
                                                        $state.go('RatingRo');
                                                    }
                                                }
                                            ]
                              });
           }
           
        }
        
    }
    app.controller("LoginController", LoginController);
} ());
