// Ionic Starter App
// angular.module is a global place for creating, registering and retrieving Angular modules
// 'FuelIoc' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'FuelIoc.controllers' is found in controllers.js

var FuelIocApp=angular.module('FuelIoc', ['ionic', 'FuelIoc.controllers','pascalprecht.translate','angularSoap','ngCordova']);

 
FuelIocApp.factory('LoginUser', function(){
    var User={          userId:"",
                        name:"",
                        email:"",
                        mobile:"",
                        address:"",
                        city:"",
                        pincode:"",
                        xtraReward:0,
                        gender:""
              };
    return User;
});
FuelIocApp.factory("ecfsService", ['$soap',function($soap){
    var base_url = "http://spandan.indianoil.co.in/eCFS_WS/SwachhBharat";
    

    return {
        postComplaint: function(imageDt, userData, userProfile) {
            try {
                var args = {
                    "parameter": {
                        "comp_dist_code": userData.rocode,
                        "comp_subcat": "9",
                        "comp_subcat_desc_1": userData.choiceDesc,
                        "comp_subj": "Swachh Bharat Abhiyan feedback",
                        "fb_mode": "7",
                        "user_addr1": userProfile.address,
                        "user_addr2": " ",
                        "user_addr3": " ",
                        "user_city": userProfile.city,
                        "user_dob": userProfile.dob,
                        "user_email": userProfile.email,
                        "user_mobileno": userData.mobile,
                        "user_name": userData.name,
                        "user_sex": userProfile.gender,
                        "user_title": "Mr"
                    },
                    "arg1": imageDt
                };

                //alert(JSON.stringify(args));
                return $soap.post(base_url, "insertComplaint", args);
            }
            catch (err) {
                alert('Problem occured. Try again');
            }

        }
    }
}]);

FuelIocApp.config(function ($translateProvider) {
    $translateProvider.useStaticFilesLoader({
        'prefix': 'locals/locale-',
        'suffix': '.json'
    });
    $translateProvider.preferredLanguage('English');
});

FuelIocApp.run(function($ionicPlatform,  $ionicPopup, $cordovaNetwork, $rootScope, $cordovaSplashscreen, $state, GeoRoService, userService) {

  $ionicPlatform.ready(function() {
    
      

      //For Push notification
      /*
      var pushNotification = window.plugins.pushNotification;
      var onNotification = function(e) {

          switch (e.event) {
              case 'registered':
                  if (e.regid.length > 0) {

                      var device_token = e.regid;
                      RequestsService.register(device_token).then(function(response) {
                          alert('registered!');
                      });
                  }
                  break;

              case 'message':
                  alert('msg received: ' + e.message);
                 
                  break;

              case 'error':
                  alert('error occured');
                  break;

          }
      };
      function errorHandler()
      {
          
      }
      pushNotification.register(
          onNotification,
          errorHandler,
          {
              'badge': 'true',
              'sound': 'true',
              'alert': 'true',
              'ecb': 'onNotification',
              'senderID': '730355745722',
          }
      );
      */
  }); 
  
  
  
 $rootScope.$on('$cordovaNetwork:offline', function(event, networkState){
  $state.go('NWLost');
 });
 
 $rootScope.$on('$cordovaNetwork:online', function(event, networkState){
   $state.go('login');
 });
  $ionicPlatform.ready(function() {
   /* if(typeof analytics !="undefined") {
       analytics.startTrackerWithId("UA-79925759-1");
    } */
    GeoRoService.intialiseGeoRoService();
    if($cordovaNetwork.isOffline()) {
        //alert('online');
        $ionicPopup.confirm({
          title: 'No Internet Connection',
          content: 'Sorry, no Internet connectivity detected. Please reconnect and try again.'
        })
        .then(function(result) {
          if(!result) {
            ionic.Platform.exitApp();
          }
          else{
              $state.go('NWLost');
          }
        });
    }
    
    //Supporting functions for back button events
      $ionicPlatform.registerBackButtonAction(function () {
                
                var view = userService.getpreviousView();
                if(view && view!="")
                {
                    $state.go(view); 
                }
                
      }, 100);
     
  });
})

FuelIocApp.config(function ($compileProvider) {
$compileProvider.imgSrcSanitizationWhitelist(/^\s*(https|ftp|mailto|file|tel|data)/);})

FuelIocApp.config(function($stateProvider, $urlRouterProvider) {
  $stateProvider

    .state('app', {
    url: '/app',
    abstract: true,
    templateUrl: 'templates/menu.html',
    controller: 'MainController'
  })
  
   .state('login', { cache: false,url: '/login',templateUrl: 'templates/login.html',controller: 'LoginController'})
   .state('register', { cache: false,url: '/register',templateUrl: 'templates/register.html',controller: 'LoginController'})
   .state('map', {cache: false,url: "/map",templateUrl: "templates/Map.html",controller: 'MapController'})
   .state('tips', {cache: false,url: "/tips",templateUrl: "templates/Tips.html",controller: 'TipsController'})
   .state('safety', {cache: false,url: "/safety",templateUrl: "templates/Safety.html",controller: 'SafetyController'})
   .state('lubes', {cache: false,url: "/safety/lubes",templateUrl: "templates/Lubes.html",controller: 'LubesController'})
   .state('pressure', {cache: false,url: "/",templateUrl: "templates/AirPressure.html",controller: 'AirPressureController'})
   .state('mydata', {url: "/",templateUrl: "templates/Mydata.html",controller: 'MydataController'})
   .state('profile', {cache: false,url: "/mydata/profile",templateUrl: "templates/Profile.html",controller: 'ProfileController'})
   .state('feedback', {cache: false,url: "/mydata/feedback",templateUrl: "templates/FeedBack.html",controller: 'FeedBackController'})
   .state('vehicle', {cache: false,url: "/mydata/vehicle",templateUrl: "templates/Vehicles.html",controller: 'VehicleController'})
   .state('ebill', {cache: false,url: "/",templateUrl: "templates/EBill.html",controller: 'EBillController'})
   .state('rstPassword', {url: "/",templateUrl: "templates/ResetPassword.html",controller: 'ResetPController'})
   .state('xtrarewards', {cache: false,url: "/mydata/xtrarewards",templateUrl: "templates/Xtrarewards.html",controller: 'XtrdsController'})
   .state('connect', {url: "/connect",templateUrl: "templates/Connect.html",controller: 'MainController'})
   .state('settings', {url: "/settings",templateUrl: "templates/Settings.html",controller: 'MainController'})
   .state('feedbackus', {cache: false,url: "/feedbackus",templateUrl: "templates/Feedbackus.html",controller: 'GnrlFbController'})
   .state('offers', {cache: false,url: "/offers",templateUrl: "templates/offers.html",controller: 'OffersController'})
   .state('NWLost', {url: "/NWLost",templateUrl: "templates/NWLost.html",controller: 'NWLostController'})
   .state('RatingRo', {url: "/rating",templateUrl: "templates/Rating.html",controller: 'RatingController'})
   .state('versionMgmt', { url: "/VersionMgmt", templateUrl: "templates/VersionMgmt.html", controller: 'VersionController' })
   .state('SBharat', {url: "/SBharat",templateUrl: "templates/SBharat.html",controller: 'SBharatController'})
   .state('Prebook', {url: "/Prebook",templateUrl: "templates/Prebook.html",controller: 'PrebookController'})
   .state('Transactions', {url: "/Transactions",templateUrl: "templates/Transactions.html",controller: 'TransactionsController'})
    .state('app.home', {
      url: '/Home',
      views: {
        'menuContent': {
          templateUrl: 'templates/Home.html',
          controller: 'MainController'
        }
      }
    });
  // if none of the above states are matched, use this as the fallback
  $urlRouterProvider.otherwise('/login');
});
