(function() {
    'use strict';
    angular.module('ionic-ratings', ['ionic'])
        .directive('ionicRatings', ionicRatings);

    function ionicRatings() {
        return {
            restrict: 'AE',
            replace: true,
            template: '<div class="text-center ionic_ratings">' +
            '<span class="icon {{iconOff}} ionic_rating_icon_off" ng-style="iconOffColor" ng-click="ratingsClicked(1)" ng-show="rating < 1" ng-class="{\'read_only\':(readOnly)}"></span>' +
            '<span class="icon {{iconOn}} ionic_rating_icon_on" ng-style="iconOnColor" ng-click="ratingsUnClicked(1)" ng-show="rating > 0" ng-class="{\'read_only\':(readOnly)}"></span>' +
            '<span class="icon {{iconOff}} ionic_rating_icon_off" ng-style="iconOffColor" ng-click="ratingsClicked(2)" ng-show="rating < 2" ng-class="{\'read_only\':(readOnly)}"></span>' +
            '<span class="icon {{iconOn}} ionic_rating_icon_on" ng-style="iconOnColor" ng-click="ratingsUnClicked(2)" ng-show="rating > 1" ng-class="{\'read_only\':(readOnly)}"></span>' +
            '<span class="icon {{iconOff}} ionic_rating_icon_off" ng-style="iconOffColor" ng-click="ratingsClicked(3)" ng-show="rating < 3" ng-class="{\'read_only\':(readOnly)}"></span>' +
            '<span class="icon {{iconOn}} ionic_rating_icon_on" ng-style="iconOnColor" ng-click="ratingsUnClicked(3)" ng-show="rating > 2" ng-class="{\'read_only\':(readOnly)}"></span>' +
            '<span class="icon {{iconOff}} ionic_rating_icon_off" ng-style="iconOffColor" ng-click="ratingsClicked(4)" ng-show="rating < 4" ng-class="{\'read_only\':(readOnly)}"></span>' +
            '<span class="icon {{iconOn}} ionic_rating_icon_on" ng-style="iconOnColor" ng-click="ratingsUnClicked(4)" ng-show="rating > 3" ng-class="{\'read_only\':(readOnly)}"></span>' +
            '<span class="icon {{iconOff}} ionic_rating_icon_off" ng-style="iconOffColor" ng-click="ratingsClicked(5)" ng-show="rating < 5" ng-class="{\'read_only\':(readOnly)}"></span>' +
            '<span class="icon {{iconOn}} ionic_rating_icon_on" ng-style="iconOnColor" ng-click="ratingsUnClicked(5)" ng-show="rating > 4" ng-class="{\'read_only\':(readOnly)}"></span>' +
            '</div>',
            scope: {
                ratingsObj: '=ratingsobj'
            },
            link: function(scope, element, attrs) {

                //Setting the default values, if they are not passed
                scope.iconOn = scope.ratingsObj.iconOn || 'ion-ios-star';
                scope.iconOff = scope.ratingsObj.iconOff || 'ion-ios-star-outline';
                scope.iconOnColor = scope.ratingsObj.iconOnColor || 'rgb(200, 200, 100)';
                scope.iconOffColor = scope.ratingsObj.iconOffColor || 'rgb(200, 100, 100)';
                scope.rating = scope.ratingsObj.rating || 0;
                scope.minRating = scope.ratingsObj.minRating || 0;
                scope.readOnly = scope.ratingsObj.readOnly || false;
                scope.ratingsObj.reset = function() {
                    scope.rating = 0;
                };
                
                scope.ratingsObj.setRating = function(val) {
                    scope.rating = val;
                };
                //Setting the color for the icon, when it is active
                scope.iconOnColor = {
                    color: scope.iconOnColor
                };

                //Setting the color for the icon, when it is not active
                scope.iconOffColor = {
                    color: scope.iconOffColor
                };

                //Setting the rating
                scope.rating = (scope.rating > scope.minRating) ? scope.rating : scope.minRating;

                //Setting the previously selected rating
                scope.prevRating = 0;

                //Called when he user clicks on the rating
                scope.ratingsClicked = function(val) {
                    if (scope.minRating !== 0 && val < scope.minRating) {
                        scope.rating = scope.minRating;
                    } else {
                        scope.rating = val;
                    }
                    scope.prevRating = val;
                    scope.ratingsObj.callback(scope.rating);
                };

                //Called when he user un clicks on the rating
                scope.ratingsUnClicked = function(val) {
                    if (scope.minRating !== 0 && val < scope.minRating) {
                        scope.rating = scope.minRating;
                    } else {
                        scope.rating = val;
                    }
                    if (scope.prevRating == val) {
                        if (scope.minRating !== 0) {
                            scope.rating = scope.minRating;
                        } else {
                            scope.rating = 0;
                        }
                    }
                    scope.prevRating = val;
                    scope.ratingsObj.callback(scope.rating);
                };

            }
        }
    }

})();



 angular.module('FuelIoc.controllers', ['ionic', 'ngCordova', 'ionic-ratings'])

.controller('MainController', function($scope, $state, $cordovaGeolocation, $http, $ionicLoading, $timeout, $ionicPlatform, $ionicSlideBoxDelegate, 
    userService, $ionicModal, $ionicPopup, $translate,  $cordovaInAppBrowser, $cordovaDevice, $cordovaAppAvailability, $window, GeoRoService, eBillService) {

        
        $scope.language = "English";
        $scope.lShow = false;
        $scope.pShow = false;
        $scope.languageUpdateResult = "";
        $scope.passrdUpdateResult = "";
        $scope.logoDivHeight=$window.screen.height-132;
        
        var isFirst = false;
        $scope.user = userService.getUser();
        $scope.settings = {
            lang: $scope.language,
            OldPswd: "",
            NewPswrd: "",
            CPswrd: ""
        };
          
        
        
        $scope.goBack = function() 
        {      
            $ionicLoading.hide();
            $state.go('app.home');
        }
        $ionicPlatform.onHardwareBackButton(function() {
            $ionicLoading.hide();
            var view = userService.getpreviousView();
                if(view && view!="")
                {
                    $state.go(view); 
                }
        });

        $scope.slideHasChanged = function(val) {
           
        }

        //Modal window for filter
        $ionicModal.fromTemplateUrl('connectModal.html', function(modal) {
            $scope.socialModal = modal;
        },
            {
                scope: $scope,
                // The animation we want to use for the modal entrance
                animation: 'slide-in-up'
            });

        $scope.showSocialModal = function() {
            $scope.socialModal.show();
            var el = document.getElementById("socialLinks");
            el.classList.remove("fadeOutRight");

        }

        $scope.hideSocialModal = function() {
            var el = document.getElementById("socialLinks");
            //el.classList.remove("my-class");
            el.classList.add("fadeOutRight");
            $timeout(function() {
                $scope.socialModal.hide();
            }, 400);
        }

        $scope.logOut = function() {
            $ionicLoading.show({
                template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
            });
            window.localStorage.setItem('username', "");
            window.localStorage.setItem('password', "");
            $state.go('login');
            $timeout(function() {
                $ionicLoading.hide();
            }, 2000);
        }
        
        var refreshIntervalId = null;
        $scope.changeView = function(view) {
            if(view=='map')
            {
               $ionicLoading.show({
                template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Loading'
               });
               refreshIntervalId = setInterval(keepChecking, 1000);
            }
            else if(view=='mapForRating')
            {
                var myPopup = $ionicPopup.show({
                    template: 'Please Choose Retail Outlet For Rating Submission',
                    title: 'Rating',
                    scope: $scope,
                    buttons: [
                        { text: 'Cancel',
                            type: 'button-assertive'
                        },
                        {
                            text: '<b>OK</b>',
                            type: 'button-positive',
                            onTap: function(e) {
                                userService.setMapView("Rating");
                                $ionicLoading.show({
                                    template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Loading'
                                });
                                refreshIntervalId = setInterval(keepChecking, 1000);
                            }
                        }
                    ]
                });
                
                
            }
            else
            {
                userService.setpreviousView("app.home");
                $state.go(view);
            }  
        }
        
        function keepChecking()
        {
               var val= GeoRoService.isDataLoaded();
               if(val)
               {      
                   clearInterval(refreshIntervalId);
                   userService.setpreviousView("app.home");
                   $state.go('map');
               }     
        }
        
        $scope.changeToMap = function(value) {
            $state.go('map');
        }
        $scope.changeLanguage = function(val) {
            $translate.use(val);

        }
        
        $scope.leditShow = function() {
            $scope.lShow = true;
            var el = document.getElementById("edtLnge");
            el.classList.remove("fadeOutUp");
            el.classList.add("animated");
            el.classList.add("fadeInDown");
        }
        
        
        
        
        $scope.pswrdEditShow = function() {
            $scope.pShow = true;
            var el = document.getElementById("edtPsd");
            el.classList.remove("fadeOutUp");
            el.classList.add("animated");
            el.classList.add("fadeInDown");
        }

        $scope.applyLanguage = function() {
            $scope.language = $scope.settings.lang;
            $translate.use($scope.language);
            $scope.languageUpdateResult = "Language updated successfully.";
            $timeout(function() {
                var el = document.getElementById("edtLnge");
                el.classList.remove("fadeInDown");
                el.classList.add("fadeOutUp");
                $scope.lShow = false;
            }, 500);

        }
        $scope.applyCPassword = function() {

            if ($scope.settings.NewPswrd == $scope.settings.CPswrd) {
                $ionicLoading.show({
                    template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
                });
                var URL = "https://xsparsh.indianoil.in:8443/soa-infra/resources/default/RDBFuel/RSResetPass/?mobile=" + $scope.user.mobile + "&pass=" + $scope.settings.NewPswrd;

                $http.post(URL, "")
                    .success(function(data, status) {
                        $scope.passrdUpdateResult = "Password updated successfully";
                        $ionicLoading.hide();
                        $timeout(function() {
                            var el = document.getElementById("edtPsd");
                            el.classList.remove("fadeInDown");
                            el.classList.add("fadeOutUp");
                            $scope.pShow = false;
                        }, 2000);
                    }).error(function(data) {
                        $scope.passrdUpdateResult = "Error occured while resetting password";
                        $ionicLoading.hide();
                        $timeout(function() {
                            var el = document.getElementById("edtPsd");
                            el.classList.remove("fadeInDown");
                            el.classList.add("fadeOutUp");
                            $scope.pShow = false;
                        }, 2000);
                    });
            }
            else {
                $scope.passrdUpdateResult = "Passwords didn't match";
            }
        }
        $scope.openIndaneApp = function()
        {
           
            var sApp = startApp.set({
                "package": "com.indanegas"
            });

            sApp.check(function(values) 
            {
                sApp.start(function() {
                    
                }, function(error) {
                    window.open('https://play.google.com/store/apps/details?id=com.indanegas', '_system', 'location=no');
                });
            }, function(error) {
                window.open('https://play.google.com/store/apps/details?id=com.indanegas', '_system', 'location=no');
            });
      
        }
        $scope.openXtraPowerApp = function()
        {
            var sApp = startApp.set({
                "package": "com.iloopworld.iocl"
            });

            sApp.check(function(values) {
                sApp.start(function() {
                    
                }, function(error) {
                    window.open('https://play.google.com/store/apps/details?id=com.iloopworld.iocl', '_system', 'location=no');
                });
            }, function(error) {
                window.open('https://play.google.com/store/apps/details?id=com.iloopworld.iocl', '_system', 'location=no');
            });
          
        }
        $scope.$on('$ionicView.enter', function() {
           
           /* 
             mcs.MobileBackendManager.platform = new mcs.CordovaPlatform();
             mcs.MobileBackendManager.setConfig(mcs_config);
             mcsBackend = mcs.MobileBackendManager.getMobileBackend("FuelAtIOC");
             
             if(mcsBackend != null)
             {
                  mcsBackend.setAuthenticationType("basicAuth");
                 
                  mcsBackend.Authorization.authenticateAnonymous(
                  function (response, data) {
                         alert('Success');
                  }, 
                  function (statusCode, data) {
                         alert('Status code is '+statusCode+' Data is '+JSON.stringify(data));      
                  });
             }
           */
            $ionicSlideBoxDelegate.start();
            initiLiseValues();
            /* if(typeof analytics !="undefined") {
                 analytics.trackView("Home Page");
             } */


            //For OneSignal Push Notifications
            // Add to index.js or the first page that loads with your app.
            // For Intel XDK and please add this to your app.js.
 /*
            document.addEventListener('deviceready', function() {
                // Enable to debug issues.
                // window.plugins.OneSignal.setLogLevel({logLevel: 4, visualLevel: 4});

                var notificationOpenedCallback = function(jsonData) {
                    console.log('didReceiveRemoteNotificationCallBack: ' + JSON.stringify(jsonData));
                };

                window.plugins.OneSignal.init("4283ebe2-f72b-42ed-87c1-e35e5f85dacb",
                    { googleProjectNumber: "730355745722" },
                    notificationOpenedCallback);

                // Show an alert box if a notification comes in when the user is in your app.
                window.plugins.OneSignal.enableInAppAlertNotification(true);
            }, false); */
            
        });
        
        function initiLiseValues()
        {
            $scope.lShow = false;
            $scope.pShow = false;
            $scope.languageUpdateResult = "";
            $scope.passrdUpdateResult = "";
            $scope.lShow = false;
            $scope.pShow = false;
            $scope.languageUpdateResult = "";
            $scope.passrdUpdateResult = "";
            $scope.user = userService.getUser();
            $scope.settings = {
                lang: $scope.language,
                OldPswd: "",
                NewPswrd: "",
                CPswrd: ""
            };
            userService.setpreviousView("app.home");
        }
    })

    .controller('MapController', function($scope, $state, $ionicLoading, $ionicPlatform, $http, $timeout, $ionicModal, $cordovaDeviceOrientation, userService, $cordovaInAppBrowser, $ionicPopup, GeoRoService,  $translate, $rootScope) {
      
      var mapOptions = {   center: null,
                            zoom: 13,
                            mapTypeId: google.maps.MapTypeId.ROADMAP,
                            rotateControl : true,
                            disableDefaultUI: true
                        };
      var isFirst = true;
      
      //Variables for directions
      var directionsService;
      var directionsDisplay;
      
      $scope.isSearchLocationAltered = false;
      var map = new google.maps.Map(document.getElementById("map"), mapOptions);
      var markerCL = new google.maps.Marker(
                    {
                        position: null,
                        map: map,
                        icon: 'img/Map/CL.png',
                        title: 'Current Location',
                        animation: google.maps.Animation.DROP
                    });
      
      $scope.ros = null;
      $scope.searchLocation = null;
      $scope.mapOrList = 1;
      $scope.tabNumber = 1;
      $scope.IsOffersShow = false;
      $scope.RoOffers = null;
      $scope.rosCount = 0;
      var ratingRo = {
            rating_PQ: 0,
            rating_QD: 0,
            rating_S: 0,
            rating_CL: 0,
            rating_F: 0,
            rating_CT: 0
        };

        $scope.rating_PQ_Object = {
            iconOn: 'ion-ios-star',
            iconOff: 'ion-ios-star-outline',
            iconOnColor: 'rgb(1, 87, 155)',
            iconOffColor: 'rgb(1, 87, 155)',
            rating: 0,
            minRating: 0,
            readOnly: false,
            callback: function(rating) {
                ratingRo.rating_PQ = rating;
            }
        };
        $scope.rating_QD_Object = {
            iconOn: 'ion-ios-star',
            iconOff: 'ion-ios-star-outline',
            iconOnColor: 'rgb(1, 87, 155)',
            iconOffColor: 'rgb(1, 87, 155)',
            rating: 0,
            minRating: 0,
            readOnly: false,
            callback: function(rating) {
                ratingRo.rating_QD = rating;
            }
        };
        $scope.rating_S_Object = {
            iconOn: 'ion-ios-star',
            iconOff: 'ion-ios-star-outline',
            iconOnColor: 'rgb(1, 87, 155)',
            iconOffColor: 'rgb(1, 87, 155)',
            rating: 0,
            minRating: 0,
            readOnly: false,
            callback: function(rating) {
                ratingRo.rating_S = rating;
            }
        };
        $scope.rating_CL_Object = {
            iconOn: 'ion-ios-star',
            iconOff: 'ion-ios-star-outline',
            iconOnColor: 'rgb(1, 87, 155)',
            iconOffColor: 'rgb(1, 87, 155)',
            rating: 0,
            minRating: 0,
            readOnly: false,
            callback: function(rating) {
                ratingRo.rating_CL = rating;
            }
        };
        $scope.rating_F_Object = {
            iconOn: 'ion-ios-star',
            iconOff: 'ion-ios-star-outline',
            iconOnColor: 'rgb(1, 87, 155)',
            iconOffColor: 'rgb(1, 87, 155)',
            rating: 0,
            minRating: 0,
            readOnly: false,
            callback: function(rating) {
                ratingRo.rating_F = rating;
            }
        };
        $scope.rating_CT_Object = {
            iconOn: 'ion-ios-star',
            iconOff: 'ion-ios-star-outline',
            iconOnColor: 'rgb(1, 87, 155)',
            iconOffColor: 'rgb(1, 87, 155)',
            rating: 0,
            minRating: 0,
            readOnly: false,
            callback: function(rating) {
                ratingRo.rating_CT = rating;
            }
        };
        
      $scope.feedback = { type: "0" };
      /* Filter Related Variables */
      $scope.filterState = 0;
      $scope.is24x7Checked = { val: false };
      $scope.tabFilterNumber = 1;
      $scope.products = [{
                Name: "Petrol",
                key: "PETROL",
                LKEY:"PETROL",
                checked: false
            },
            {
                Name: "XTRAPREMIUM Petrol",
                key: "XTRAPREMIUM",
                LKEY:"XTRAPREMIUMP",
                checked: false
            },
            {
                Name: "Diesel",
                key: "DIESEL",
                LKEY:"DIESEL",
                checked: false
            },
            {
                Name: "XTRAMILE Super Diesel",
                key: "XTRAMILE",
                LKEY:"XTRAMILES",
                checked: false
            }];

        $scope.services = [{
            Name: "ATM",
            value: "ATM",
            key: "ATM",
            checked: false
        },
            {
                Name: "Card",
                value: "Card",
                key: "CARD",
                checked: false
            },
            {
                Name: "Dhaba",
                value: "DHABA",
                key: "DHABA",
                checked: false
            },
            {
                Name: "Washroom",
                value: "Washroom",
                key: "WASHROOM",
                checked: false
            },
            {
                Name: "PUC",
                value: "PUC",
                key: "PUC",
                checked: false
            },
            {
                Name: "Air",
                value: "Air",
                key: "AIR",
                checked: false
            },
            {
                Name: "Drinking Water",
                value: "Clean Drinking Water",
                key: "CLEANDRINKINGWATER",
                checked: false
            },
            {
                Name: "Service Station",
                value: "SERVICESTN",
                key: "SERVICESTATION",
                checked: false
            },
            {
                Name: "Automation",
                value: "Automation",
                key: "AUTOMATION",
                checked: false
            },
            {
                Name: "Separate Toilet",
                value: "Separate Toilet",
                key: "SEPARATETOILET",
                checked: false
            },
            {
                Name: "Xtrapower",
                value: "Xtrapower",
                key: "XTRAPOWER",
                checked: false
            },
            {
                Name: "Xtrareward",
                value: "Xtrareward",
                key: "XTRAREWARD",
                checked: false
            },
            {
                Name: "Networked RO",
                value: "Networked RO",
                key: "NETWORKEDRO",
                checked: false
            }];

            
      
      function successCallBack(ros, clocation, AreRosChanged)
      {
          if(isFirst)
          {
              map.setCenter(clocation);
              isFirst = false;
          }
          if(!$scope.isSearchLocationAltered)
          {
              markerCL.setPosition(clocation);     
              if(AreRosChanged || $scope.ros==null)
              {
                for(i=0;i<ros.length;i++)
                {
                    ros[i].marker.setMap(map);
                    google.maps.event.addListener(ros[i].marker, 'click', (function(marker, i) {
                                return function() {
                                    $scope.ro = ros[i];
                                    $scope.ro.isRatingSubmit = false;
                                    $scope.ro.isFeedbackSubmit = false;
                                    $scope.showRo();
                                }
                    })(ros[i].marker, i));
                }
                $scope.ros = ros;
                $scope.rosCount = $scope.ros.length;
              }
          }
          
      }
      
      function errorCallback(error)
      {
         // alert('Error in watch location'+error);
      }
      
      function initialise()
      {
          $scope.ros = GeoRoService.returnRos();;
          var cl= GeoRoService.returnCL();
          
          if(cl)
          {
                markerCL.setPosition(cl);
                map.setCenter(cl);
          }
            
          if($scope.ros.length)
          {
              $scope.rosCount = $scope.ros.length;
              for(i=0;i<$scope.ros.length;i++)
              {
                 $scope.ros[i].marker.setMap(map);
                 google.maps.event.addListener($scope.ros[i].marker, 'click', (function(marker, i) {
                                return function() {
                                    $scope.ro = $scope.ros[i];
                                    $scope.ro.isRatingSubmit = false;
                                    $scope.ro.isFeedbackSubmit = false;
                                    $scope.showRo();
                                }
                 })($scope.ros[i].marker, i));
              }
          }
          else{
              $scope.rosCount = 0;
              alert('No Fuel Station Found');
          }  
      }
      
      //For auot complete text box
      $scope.disableTap = function() {
            var container = document.getElementsByClassName('pac-container');
            // disable ionic data tab
            angular.element(container).attr('data-tap-disabled', 'true');
            // leave input field if google-address-entry is selected
            angular.element(container).on("click", function() {
                document.getElementById('searchInput').blur();
            });
      }
      function addAutoComplete() {
            var addressTextField = document.getElementById('searchInput');
            var autocomplete, placeSearch;
            var defaultBounds = new google.maps.LatLngBounds(new google.maps.LatLng(35.5087008, 97.395561), new google.maps.LatLng(6.7535159, 68.16288519999999));

            var options = {

                bounds: defaultBounds,

                types: ['geocode']

            };

            //Setting up the autocomplete google places feature.

            autocomplete = new google.maps.places.Autocomplete(addressTextField, options);

            var nL = null; 
            autocomplete.addListener('place_changed', function() {
                $ionicLoading.show({
                    template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Acquiring Fuel Pumps!'
                });
                
                var place = autocomplete.getPlace();
                nL = new google.maps.LatLng(place.geometry.location.lat(), place.geometry.location.lng());
                GeoRoService.getRos(place.geometry.location.lat(), place.geometry.location.lng(), success, error);
                                                                   
            });
            function success(ROS, location, val)
            {
                ros= GeoRoService.returnRos();
                markerCL.setPosition(nL);
                map.panTo(nL);
                $scope.isSearchLocationAltered = true;
                $scope.searchLocation = location;
                
                for(i=0;i<ros.length;i++)
                {
                    ros[i].marker.setMap(null);
                }
                
                if(ROS&&ROS.length>0)
                {
                    for(i=0;i<ROS.length;i++)
                    {
                        ROS[i].marker.setMap(map);
                    }
                
                    $scope.ros=ROS;
                    $scope.rosCount = $scope.ros.length;
                    for(i=0;i<$scope.ros.length;i++)
                    {
                        google.maps.event.addListener($scope.ros[i].marker, 'click', (function(marker, i) {
                                return function() {
                                    $scope.ro = $scope.ros[i];
                                    $scope.ro.isRatingSubmit = false;
                                    $scope.ro.isFeedbackSubmit = false;
                                    $scope.showRo();
                                }
                        })($scope.ros[i].marker, i));
                    }
                }
                else
                {
                    $scope.ros = null;
                    $scope.rosCount = 0;
                }
        
                $ionicLoading.hide();
            }
            function error(data)
            {
                alert(data);
                $ionicLoading.hide();
            }
            $scope.resetFilter();
        }
      
      $scope.changeToOriginalLocation = function()
      {
          var cl= GeoRoService.returnCL();
          markerCL.setPosition(cl);
          map.setCenter(cl);
          if($scope.ros)
          {
              for(i=0;i<$scope.ros.length;i++)
              {
                    $scope.ros[i].marker.setMap(null);
              }
          }
          
          
          $scope.ros= GeoRoService.returnRos();
          if($scope.ros&&$scope.ros.length>0)
          {
                    for(i=0;i<$scope.ros.length;i++)
                    {
                        $scope.ros[i].marker.setMap(map);
                    }
                    for(i=0;i<$scope.ros.length;i++)
                    {
                        google.maps.event.addListener($scope.ros[i].marker, 'click', (function(marker, i) {
                                return function() {
                                    $scope.ro = $scope.ros[i];
                                    $scope.ro.isRatingSubmit = false;
                                    $scope.ro.isFeedbackSubmit = false;
                                    $scope.showRo();
                                }
                        })($scope.ros[i].marker, i));
                    }
                    $scope.rosCount = $scope.ros.length;
          }
          else
          {
                    $scope.ros = null;
                    $scope.rosCount = 0;
          }
          $scope.isSearchLocationAltered = false;
          document.getElementById('searchInput').value = ""; 
          
          
          google.maps.event.addDomListener(window, 'resize', function() {
                     var center = map.getCenter();
                     map.setCenter(center);
          });
          // And aditionally you can need use "trigger" for real responsive
          google.maps.event.trigger(map, "resize");
          
      }
      
      $scope.selectRoForPayment = function(ro)
      {
              $scope.closeRo();
              $rootScope.roForPayment = ro;
              userService.setpreviousView("map");
              userService.setFromMapViewPay(true);
              $state.go('Prebook'); 
      }
      
      
      $scope.showMapTab = function() {
            $scope.mapOrList = 1;
      }

      $scope.showListTab = function() {
            $scope.mapOrList = 2;
      }
      
      //Modal Window For RO related 
      $ionicModal.fromTemplateUrl('roModal.html', function(modal) {
            $scope.modalRo = modal;
      },
      {
                scope: $scope,
                // The animation we want to use for the modal entrance
                animation: 'slide-in-up'
      });

      $scope.closeRo = function() {
            $scope.modalRo.hide();
      }

      $scope.showRo = function() {
            $scope.modalRo.show();
            resetAll();
      }
      
      $scope.showAbout = function() {

            $scope.tabNumber = 1;
      }
      $scope.showRoProducts = function() {

            $scope.tabNumber = 2;

     }
     $scope.showRoServices = function() {
           
            $scope.tabNumber = 3;
     }
     
     $scope.showRoRating = function() {

            $scope.tabNumber = 4;
            
     }
     
     $scope.postRating = function() {
            if ($scope.ro.rocode && ratingRo.rating_PQ != 0 && ratingRo.rating_QD != 0 && ratingRo.rating_S && ratingRo.rating_CL != 0 && ratingRo.rating_F != 0 && ratingRo.rating_CT != 0) {
                $ionicLoading.show({
                    template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Posting rating!'
                });
                var content = {
                                  FaiFeedbackRating:{
                                        roCode: $scope.ro.rocode,
                                        productQuality: ratingRo.rating_PQ,
                                        quantityDelivered: ratingRo.rating_QD,
                                        service: ratingRo.rating_S,
                                        facilities: ratingRo.rating_CL,
                                        cleaniness: ratingRo.rating_F,
                                        cleantoilet: ratingRo.rating_CT,
                                        userId: $scope.user.mobile,
                                        txnId: "0",
                                        roAtdId: "0",
                                        feedbackFrom: "FUELAIOC",
                                        remarks: $scope.remarks.content

                                    }
                                };

                
                
                var request = $http.post('https://xsparsh.indianoil.in:8443/soa-infra/resources/default/RDBXS/RSFBRating/ ', content);
               
                request.success(
                    function(html) {
                        $ionicLoading.hide();
                        $scope.ro.isRatingSubmit = true;
                        $scope.ro.ratingStatus = "Thank you for your valuable rating";

                        //Sending sms for rating 
                        var avgRtng = 0, msg = "";
                        /*
                        avgRtng = (ratingRo.rating_PQ + ratingRo.rating_QD + ratingRo.rating_S + ratingRo.rating_CL + ratingRo.rating_F + ratingRo.rating_CT) / 6;

                        if (avgRtng >= 3) {
                            msg = 'Dear ' + $scope.user.name + ', Thanks for your valuable feedback on  Indian Oil  Petrol Pump M/s. ' + $scope.ro.roname + '. We appreciate your feedback and strive to serve you better. Thanks for patronizing Fuel@IOC';
                        }
                        else {
                            msg = 'Dear ' + $scope.user.name + ', Thanks for your valuable feedback on  Indian Oil  Petrol Pump M/s. ' + $scope.ro.roname + '. This will be useful in improving our services. Thanks for patronizing Fuel@IOC';
                        }
                        */
                        
                       

                        

                        var getRtdRos = userService.getRtdRos();
                        var isFound = false;
                        for(k=0;k<getRtdRos.length;k++)
                        {
                            if(getRtdRos[k].ro_code==parseInt($scope.ro.rocode))
                            {
                                isFound = true;
                            }
                        }
                        if(!isFound)
                        {

                            if (ratingRo.rating_PQ >= 3 && ratingRo.rating_QD >= 3 && ratingRo.rating_S >= 3 && ratingRo.rating_CL >= 3 && ratingRo.rating_F >= 3 && ratingRo.rating_CT >= 3) {
                                sendFormatedSms($scope.user.name, $scope.ro.roname, $scope.user.mobile, 1);
                            }
                            else {
                                sendFormatedSms($scope.user.name, $scope.ro.roname, $scope.user.mobile, -1);
                            }

                            
                            userService.populateRtdRos($scope.user.mobile);
                        }
                        
                    }
                ).error(ratingError);
            }
            else {
                alert('Please rate all categories');
            }

        }
        function ratingError(data) {
           
            $scope.ro.isRatingSubmit = true;
            $scope.ro.ratingStatus = "Rating service is not available";
            $ionicLoading.hide();
        }
     
     
     
     
     $scope.showFeedback = function() {

            $scope.tabNumber = 5;
     }
     $scope.postFeedback = function() {

            if ( $scope.feedback.descr && $scope.feedback.descr.length != 0) {
                $ionicLoading.show({
                    template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Posting Feedback!'
                });

                //Field length checking for eCFS
                var tempUser ={
                    address :"",
                    subject :"",
                    email   :"",
                    name    :""
                };
                if($scope.user.address!=null&&$scope.user.address.length>49)
                {
                    tempUser.address = $scope.user.address.substring(0,48);
                }
                else
                {
                    tempUser.address = $scope.user.address;
                }
                if($scope.feedback.subject!=null&&$scope.feedback.subject.length>50)
                {
                   tempUser.subject = $scope.feedback.subject.substring(0,48);
                }
                else
                {
                    tempUser.subject = $scope.feedback.subject;
                }
                if($scope.user.email!=null&&$scope.user.email.length>50)
                {
                    tempUser.email = $scope.user.email.substring(0,48);
                }
                else
                {
                    tempUser.email = $scope.user.email;
                }
                if($scope.user.name!=null&&$scope.user.name.length>50)
                {
                    tempUser.name = $scope.user.name.substring(0,48);
                }
                else
                {
                    tempUser.name = $scope.user.name;
                }
                
                
                
                if ($scope.feedback.Ftype == "1") 
                {
                    if($scope.feedback.type != "0" &&$scope.feedback.subject && $scope.feedback.subject.length != 0)
                    {
                        
                        var requestContent = {
                            "parameter":
                            {
                                "comp_dist_code": $scope.ro.rocode,
                                "comp_subcat": $scope.feedback.type,
                                "comp_subcat_desc_1": $scope.feedback.descr,
                                "comp_subj": tempUser.subject,
                                "user_addr1": tempUser.address,
                                "user_addr2": " ",
                                "user_addr3": " ",
                                "user_city": $scope.user.city,
                                "user_dob": "22011989",
                                "user_email": tempUser.email,
                                "user_mobileno": $scope.user.mobile,
                                "user_name": tempUser.name,
                                "user_sex": $scope.user.gender,
                                "user_title": "Mr"
                            }
                        };
                        
                        //alert(JSON.stringify(requestContent));
                        
                        var request = $http({
                        method: "post",
                        url: "https://xsparsh.indianoil.in:8443/soa-infra/resources/default/RDBFuel/RSeCFSInsert/",
                        headers: {
                            'Content-Type': 'application/json; charset=UTF-8',
                            'Accept': 'application/json'
                        },
                        data: {
                            "parameter":
                            {
                                "comp_dist_code": $scope.ro.rocode,
                                "comp_subcat": $scope.feedback.type,
                                "comp_subcat_desc_1": $scope.feedback.descr,
                                "comp_subj": tempUser.subject,
                                "user_addr1": tempUser.address,
                                "user_addr2": " ",
                                "user_addr3": " ",
                                "user_city": $scope.user.city,
                                "user_dob": "22011989",
                                "user_email": tempUser.email,
                                "user_mobileno": $scope.user.mobile,
                                "user_name": tempUser.name,
                                "user_sex": $scope.user.gender,
                                "user_title": "Mr"
                            }
                        }
                    });
                    request.success(
                        function(html) {
                            $ionicLoading.hide();
                            $scope.ro.isFeedbackSubmit = true;
                            $scope.ro.feedbackStatus = html.return; 
                        }
                    ).error(feedbkError); 
                  }
                  else
                  {
                      alert('Please fill all details');
                  }
                    
                }
                else {
                    
                    var request = $http({
                        method: "post",
                        url: "https://xsparsh.indianoil.in:8443/soa-infra/resources/default/RDBFuel/RSFeedback",
                        headers: {
                            'Content-Type': 'application/json; charset=UTF-8',
                            'Accept': 'application/json'
                        },
                        data: {
                            "FaiFdComp": [
                                {
                                    "roCode": $scope.ro.rocode,
                                    "userId": $scope.user.mobile,
                                    "category": "Feedback",
                                    "subCategory": $scope.feedback.type,
                                    "description": $scope.feedback.descr
                                }
                            ]
                        }

                    });
                    request.success(
                        function(html) {
                            $ionicLoading.hide();
                            $scope.ro.isFeedbackSubmit = true;
                            $scope.ro.feedbackStatus = "Thank you for your valuable feedback";
                            
                            var msg = 'Dear ' + $scope.user.name + ', Thanks for your valuable feedback on  Indian Oil  Petrol Pump M/s. ' + $scope.ro.roname + '.Your appreciation will motivate us to serve you better. We thank you for patronising  "Fuel@IOC"';
                            /*
                            var content = {
                                "mobile_no": $scope.user.mobile,
                                "sms_content": msg,
                                "sms_type": "ENG",
                                "userID": "WEBS",
                                "password": "WEBS@USER765"
                            };

                            $http.post("https://xsparsh.indianoil.in:8443/soa-infra/resources/default/RDBFuel/RSSendSMS/", content)
                                .success(function(data, status) {
                            });
                            */

                            var content =
                                {
                                    "mobile_no": $scope.user.mobile,
                                    "sms_text": msg,
                                    "user_id": "FUEL@IOC",
                                    "password": "FUEL@IOC123",
                                    "app_name": "Feedback_FuelAIOC",   /// Swachh, OTP, feedback etc.
                                    "dealer_code":  $scope.ro.rocode  /// pass 0 if not available in case of OTP, general feedback etc.
                                };


                            $http.post("https://xsparsh.indianoil.in:8443/soa-infra/resources/default/RDBFuel/RSSendSMSv2/", content)
                                .success(function(data, status) {
                                });
                        }
                    ).error(feedbkError);
                }
            }
            else {
                alert('Please fill all details');
            }

        }
        function feedbkError(data) {
            
            $scope.ro.isFeedbackSubmit = true;
            $scope.ro.feedbackStatus = "Feedback service not available";
            $ionicLoading.hide();
        }
     
     
     function resetAll() {
            
            $scope.rating_PQ_Object.reset();
            $scope.rating_QD_Object.reset();
            $scope.rating_S_Object.reset();
            $scope.rating_CL_Object.reset();
            $scope.rating_F_Object.reset();
            $scope.rating_CT_Object.reset();

            
            $scope.feedback.type = "0";
            $scope.feedback.subject = "";
            $scope.feedback.descr = "";
            $scope.remarks = {
              content : ""
            };
    }
     
     
     $scope.zoomToRo = function(ro) {
            
            $ionicLoading.show({
                template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Zooming To Location'
            });
            var x = new google.maps.LatLng(ro.latitude, ro.longitude)
            map.setZoom(17);
            map.setCenter(x);
            $scope.mapOrList = 1;
            $timeout(function() {
                $ionicLoading.hide();
            }, 1000);
            directionsDisplay.setMap(null);
     }
    $scope.findRoute = function(ro) {
            var x = new google.maps.LatLng(ro.latitude, ro.longitude);
            var start;
            map.setZoom(15);
            map.setCenter(x);
            $scope.mapOrList = 1;
            
            if($scope.isSearchLocationAltered)
            {
                start = $scope.searchLocation;
            }
            else
            {
                start = GeoRoService.returnCL();
            }
            var end = x;


            directionsDisplay.setMap(null);

            var request = {
                origin: start,
                destination: end,
                travelMode: google.maps.TravelMode.DRIVING
            };
            directionsService.route(request, function(result, status) {

                
                if (status == google.maps.DirectionsStatus.OK) {
                   
                    directionsDisplay.setMap(map);
                    directionsDisplay.setDirections(result);
                    $timeout(function() {
                        $ionicLoading.hide();
                    }, 1000);
                    $scope.closeRo();
                }
            });
   }
     
     
     //Modal Window For Filter related
     $ionicModal.fromTemplateUrl('filterModal.html', function(modal) {
            $scope.modalFilter = modal;
     },
     {
           scope: $scope,
                // The animation we want to use for the modal entrance
           animation: 'slide-in-up'
     });

     $scope.closeFilter = function() {
            $scope.modalFilter.hide();
     }

     $scope.showFilter = function() {
            $scope.modalFilter.show();
     }
     $scope.showFilterProducts = function() {

            $scope.tabFilterNumber = 1;
     }
     $scope.showFilterServices = function() {

            $scope.tabFilterNumber = 2;

     }
     $scope.apply24x7 = function(val) {
            if (val) {
                $scope.filterState++;
                
            }
            else {
                $scope.filterState--;
            }
            if ($scope.filterState == 0) {
                //$scope.mapRoFilter();
            }

        }
        $scope.applyProduct = function(val) {
            if (val.checked) {
                $scope.filterState++;
                
            }
            else {
                $scope.filterState--;
            }
            if ($scope.filterState == 0) {
                //$scope.mapRoFilter();
            }
        }
        $scope.applyService = function(val) {
            if (val.checked) {
                $scope.filterState++;
               
            }
            else {
                $scope.filterState--;
            }
            if ($scope.filterState == 0) {
                //$scope.mapRoFilter();
            }

        }
        $scope.resetFilter = function() {
            $scope.is24x7Checked.val = false;

            for (i = 0; i < $scope.products.length; i++) {
                $scope.products[i].checked = false;
            }
            for (i = 0; i < $scope.services.length; i++) {
                $scope.services[i].checked = false;
            }

            $scope.filterState = 0;

        }
        
        function sendFormatedSms(userName, dealerName, mobile, val)
        {
            $http.get("https://xsparsh.indianoil.in:8443/soa-infra/resources/default/Notifications/RSFbSMS?app_name=FUELAIOC")
                .success(function(data, status) {
                    var msg;
                    if(data.FaiRatingSms[0].msgType == val)
                    {
                        msg = data.FaiRatingSms[0].msgText;
                    }
                    else{
                        msg = data.FaiRatingSms[1].msgText;
                        
                        
                    }
                    msg = msg.replace("$username$", userName);
                    msg = msg.replace("$roname$", dealerName);
                    

                   var content =
                            {
                                "mobile_no": mobile,
                                "sms_text": msg,
                                "user_id": "FUEL@IOC",
                                "password": "FUEL@IOC123",
                                "app_name": "Rating_FuelAIOC",   /// Swachh, OTP, feedback etc.
                                "dealer_code": $scope.ro.rocode /// pass 0 if not available in case of OTP, general feedback etc.
                            };

                    $http.post("https://xsparsh.indianoil.in:8443/soa-infra/resources/default/RDBFuel/RSSendSMSv2/", content)
                                .success(function(data, status) {
                    });

                }).error(function() {
                    console.log("Error in sending SMS");
                });
        }
        
        
        $scope.mapRoFilter = function() {

            var result = true;
            var count = 0;
            var isNearest = false;
            var bounds = new google.maps.LatLngBounds();
            var boundsCount = 0;
            directionsDisplay.setMap(null);
            
            if($scope.isSearchLocationAltered)
            {
                bounds.extend($scope.searchLocation);
            }
            else
            {
                bounds.extend(GeoRoService.returnCL());
            }
            

           
            $ionicLoading.show({
                template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Loading'
            });
            for (i = 0; i < $scope.ros.length; i++) {
                if ($scope.is24x7Checked.val) {
                   
                    if ($scope.ros[i].worktimingstart != "00:00" || $scope.ros[i].worktimingend != "00:00") {
                        result = false;
                        
                    }
                }
                if (result) {
                    for (k = 0; k < $scope.products.length; k++) {
                        if ($scope.products[k].checked) {
                            
                            for (j = 0; j < $scope.ros[i].products.length; j++) {
                                if ($scope.products[k].key == $scope.ros[i].products[j].name && !$scope.ros[i].products[j].IsAvailable) {
                                    result = false;
                                    break;
                                }
                            }

                        }
                        if (!result) {
                            break;
                        }
                    }
                }

                if (result) {
                    for (k = 0; k < $scope.services.length; k++) {
                        if ($scope.services[k].checked) {
                            
                            var IsServiceFind = false;
                            for (j = 0; j < $scope.ros[i].services.length; j++) {
                                if ($scope.services[k].value == $scope.ros[i].services[j]) {
                                    IsServiceFind = true;
                                    break;
                                }
                            }
                            if (!IsServiceFind) {
                                result = false;
                            }

                        }
                        if (!result) {
                            break;
                        }
                    }
                }

                if (!result) {
                    $scope.ros[i].marker.setMap(null);
                    $scope.ros[i].IsFilterSatisfied = false;
                    $scope.ros[i].isNearest = false;
                    $scope.ros[i].marker.setIcon('img/Map/fuelIcon.png');
                }
                else {
                    if (!isNearest) {
                        $scope.ros[i].isNearest = true;
                        $scope.ros[i].marker.setIcon('img/Map/fuelIconN.png');
                        isNearest = true;
                    }
                    else {
                        $scope.ros[i].isNearest = false;
                        $scope.ros[i].marker.setIcon('img/Map/fuelIcon.png');
                    }
                    $scope.ros[i].marker.setMap(map);
                    $scope.ros[i].IsFilterSatisfied = true;
                    boundsCount++;
                    if (boundsCount < 5) {
                        bounds.extend($scope.ros[i].marker.getPosition());
                    }

                    count++;
                }
                result = true;
            }

            $scope.rosCount = count;
            map.setCenter($scope.clocation);
            map.fitBounds(bounds);
            $scope.closeFilter();
            $timeout(function() {
                $ionicLoading.hide();
            }, 1000);
        }
        function isEmpty(str) {
            return (!str || 0 === str.length);
        }
        $scope.resetFilter = function() {
            $scope.is24x7Checked.val = false;

            for (i = 0; i < $scope.products.length; i++) {
                $scope.products[i].checked = false;
            }
            for (i = 0; i < $scope.services.length; i++) {
                $scope.services[i].checked = false;
            }

            $scope.filterState = 0;

        }
        $scope.changeService = function(val)
        {
            return val.replace(/ /g,'').toUpperCase();
        }
      
      
      
      
      $scope.goBack = function() 
      {   
            for(i=0;i<$scope.ros.length;i++)
            {
                  $scope.ros[i].marker.setMap(null);
            }
            directionsDisplay.setMap(null);
            $scope.resetFilter();
            GeoRoService.stopWatchLocation();
            document.getElementById('searchInput').setAttribute("disabled", true);
            $ionicLoading.hide();
            var preView = userService.getpreviousView();
            $state.go(preView); 
            
      }
      $scope.isValid = function(val)
      {
            if(val)
            {
                return JSON.stringify(val).indexOf('@nil')<0;
            }
            else{
                return false;
            }
            
      }
      $scope.getOffers = function(roCode)
      {
                var request = $http.get('https://xsparsh.indianoil.in:8443/soa-infra/resources/default/RDBFuel/RSRoPromo?roCode='+roCode, null, {
                    headers: {
                        'Content-Type': 'application/json',
                        'Accept':'application/json; charset=UTF-8'
                    }
                });

                request.success(
                    function(html) {
                       $scope.RoOffers = html.SlsprPromoDetails;
                       for(i=0;i<$scope.RoOffers.length;i++)
                       {
                           $scope.RoOffers[i].promoEndDate = $scope.RoOffers[i].promoEndDate.substring(0,10);
                       }
                       $scope.IsOffersShow = !$scope.IsOffersShow;
                    }
                ).error(onErrorOffers);
                function onErrorOffers(data)
                {
                    
                }
      }
      
      
      addAutoComplete();
      $scope.$on('$ionicView.enter', function() {
          
          $ionicLoading.show({
            template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Loading Fuel Stations'
          });
          
          $timeout(function() {
               $ionicLoading.hide();
          }, 2000);
          
          $scope.remarks = {
              content : ""
          };
          
          document.getElementById('searchInput').blur();
          document.getElementById('searchInput').value = "";
          document.getElementById('searchInput').removeAttribute('disabled');
          isFirst = true;
          $scope.isSearchLocationAltered = false;
          directionsService = new google.maps.DirectionsService();
          directionsDisplay = new google.maps.DirectionsRenderer();
          var val=userService.getMapView();
          $scope.user = userService.getUser();
          if(val=="Rating")
          {
                $scope.tabNumber = 4;
                userService.setMapView("");
          }
          else if(val=="Complaint")
          {
                $scope.tabNumber = 5;
                $scope.feedback.Ftype = "1";
                userService.setMapView("");
          }
          else
          {
                $scope.feedback.Ftype = "0";
                $scope.tabFilterNumber = 1;
          }
          directionsDisplay.setMap(null);
          $scope.resetFilter();
          GeoRoService.watchLocation(successCallBack,errorCallback); 
          initialise();
          var contentString =$translate.instant('YOUHERE');
          var infowindowCL = new google.maps.InfoWindow(
                            {
                                content: contentString
                            });           
          infowindowCL.open(map, markerCL); 
         /* if(typeof analytics !="undefined") {
                analytics.trackView("Map");
          } */
          userService.setpreviousView("app.home");
          
          if(userService.getMapView()=="RoSelection")
          {
              $scope.IsRoPmt = true; //Used for enabling ro selection for payment
          }
          else
          {
              $scope.IsRoPmt = false;
          }
          
      });
    })

    .controller('TipsController', function($scope, $state, $ionicModal, userService,  $ionicLoading) {

        $scope.changeView = function(view) { $state.go(view); }
        
        $scope.changeView = function(view) {
            userService.setpreviousView("tips");
            $state.go(view);
        }
        $scope.goBack = function() 
        {   
            $ionicLoading.hide();
            $state.go("app.home"); 
        }
        $scope.$on('$ionicView.enter', function() {
            userService.setpreviousView("app.home");
        });

    })
    .controller('SafetyController', function($scope, $state, $ionicModal, userService,  $ionicLoading) {

        $scope.safetyNumber = 0;
        $scope.SafetyTitle = "";
        $scope.GeneralSafeInstr = [{
            Value: "Concentrate on the road.",
            Name: "GENERAL1"
        },
            {
                Value: "Drive Defensively-develop good anticipation.",
                Name: "GENERAL2"
            },
            {
                Value: "Avoid Highway hypnosis or Drowsiness--Take short breaks.",
                Name: "GENERAL3"
            },
            {
                Value: "Do not follow a vehicle too closely--cross any object atleast 2 seconds after the vehicle ahead has crossed.",
                Name: "GENERAL4"
            },
            {
                Value: "Use common sense while driving--never exceed the max-speed limit and drive as per flow of traffic.",
                Name: "GENERAL5"
            },
            {
                Value: "Do not use cell phone while driving.",
                Name: "GENERAL6"
            }];
        $scope.RainDrivInstr = [{
            Value: "Drive Slowly on wet roads. ",
            Name: "RAINDRIVING1"
        },
            {
                Value: "Switch on the headlights during rain.",
                Name: "RAINDRIVING2"
            },
            {
                Value: "Do not use parking lights.",
                Name: "RAINDRIVING3"
            },
            {
                Value: "Reduce your speed in high winds. ",
                Name: "RAINDRIVING4"
            }];
        $scope.WinterDriveInstr = [{
            Value: "Plan your winter driving. Equip well with blankets, food and other survival equipment. ",
            Name: "WINTERDRIVING1"
        },
            {
                Value: "Keep your window open to prevent Carbon Monoxide poisoning. ",
                Name: "WINTERDRIVING2"
            },
            {
                Value: "Remove snow and ice from your vehicle. Defrost your windshield before starting. ",
                Name: "WINTERDRIVING3"
            },
            {
                Value: "Avoid driving in foggy weather. Drive slowly, stay within the limits of your vision, use headlights. ",
                Name: "WINTERDRIVING4"
            },
            {
                Value: "If fog is too dense, pull off the road and stop. Do not drive. ",
                Name: "WINTERDRIVING5"
            }];
        $scope.NightDriveInstr = [{
            Value: "Drive with caution--things appear differently than in daylight.",
            Name: "NIGHTDRIVING1"
        },
            {
                Value: "Always keep headlights cleaned and aimed properly. ",
                Name: "NIGHTDRIVING2"
            },
            {
                Value: "Do not use any light inside the vehicle. ",
                Name: "NIGHTDRIVING3"
            },
            {
                Value: "Use edge lines and centre line of road as guides. ",
                Name: "NIGHTDRIVING4"
            }];
        $scope.VechicleCheckInstr = [{
            Value: "Follow standard vehicle checks provided by your vehicle manufacturer regularly. ",
            Name: "VEHICLECHECKS1"
        }];
        $scope.ExtVechileInstr = [{
            Value: "Condition of vehicle bodywork, windscreen, windows, lights ",
            Name: "EXTERANLVEHICLECHECKS1"
        },
            {
                Value: "Condition of windscreen wiper blades. ",
                Name: "EXTERANLVEHICLECHECKS2"
            },
            {
                Value: "Cleaniness of windscreen, windows, mirrors, lights, number plates ",
                Name: "EXTERANLVEHICLECHECKS3"
            },
            {
                Value: "Condition of spare wheel and jack ",
                Name: "EXTERANLVEHICLECHECKS4"
            }];

        $ionicModal.fromTemplateUrl('modal.html', function(modal) {
            $scope.modal = modal;
        },
            {
                scope: $scope,
                // The animation we want to use for the modal entrance
                animation: 'slide-in-up'
            });

        $scope.hideSafetyTips = function() {
            $scope.modal.hide();
            $scope.safetyNumber = 0;
        }

        $scope.showSafetyTips = function(val, title, key) {
            
            $scope.safetyNumber = val;
            $scope.SafetyTitle = title;
            $scope.safetyKey = key;
            $scope.modal.show();
        }
        $scope.goBack = function() 
        {   
            $ionicLoading.hide();
            var preView = userService.getpreviousView();
            $state.go(preView); 
        }

    })
    .controller('LubesController', function($scope, $state, $ionicPlatform, $ionicLoading, $http, $timeout, $ionicModal, userService) {

        $scope.LubeSelectd = null;
        $scope.Lubes = null;
        $ionicLoading.show({
            template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Loading'
        });

        $ionicPlatform.ready(function() {

            $http.get('https://xsparsh.indianoil.in:8443/soa-infra/resources/default/RDBFuel/RSLubeRec', {}).success(function(data, status) {

            
                //var options = '';
                //for (i = 0; i < data.FaiLubeRec.length; i++) {
                //    options += '<option value="' + data.FaiLubeRec[i].make + " " + data.FaiLubeRec[i].model + '" />';
                // }
                //document.getElementById('datalist1').innerHTML = options;
               
                //document.getElementById('LubesModalTb').setAttribute("list", "datalist1");

                $scope.Lubes = data.FaiLubeRec;
               
                $timeout(function() {
                    $ionicLoading.hide();
                }, 1000);

            }).error(onError);

            function onError(data) {
                alert(data);
                $ionicLoading.hide();
            }

        });

        $scope.lubeValidatae = {
            IsEngineOilvalid: true,
            IsGearOilvalid: true,
            IsBreakvalid: true,
            IsCoolantvalid: true,
            IsSteeringvalid: true,
            IsdifferentialOilvalid: true
        };

        $scope.onLubeSelect = function(Lube) {
            $scope.LubeSelectd = Lube;
           
            if (JSON.stringify(Lube.engineOil).indexOf('@nil') >= 0) {
                $scope.lubeValidatae.IsEngineOilvalid = false;
            }
            else {
                $scope.lubeValidatae.IsEngineOilvalid = true;
            }
            if (JSON.stringify(Lube.gearOil).indexOf('@nil') >= 0) {
                $scope.lubeValidatae.IsGearOilvalid = false;
            }
            else {
                $scope.lubeValidatae.IsGearOilvalid = true;
            }
            if (JSON.stringify(Lube.differentialOil).indexOf('@nil') >= 0) {
                $scope.lubeValidatae.IsdifferentialOilvalid = false;
            }
            else {
                $scope.lubeValidatae.IsdifferentialOilvalid = true;
            }
            if (JSON.stringify(Lube.brakeFluid).indexOf('@nil') >= 0) {
                $scope.lubeValidatae.IsBreakvalid = false;
            }
            else {
                $scope.lubeValidatae.IsBreakvalid = true;
            }
            if (JSON.stringify(Lube.coolant).indexOf('@nil') >= 0) {
                $scope.lubeValidatae.IsCoolantvalid = false;
            }
            else {
                $scope.lubeValidatae.IsCoolantvalid = true;
            }
            if (JSON.stringify(Lube.steeringFluid).indexOf('@nil') >= 0) {
                $scope.lubeValidatae.IsSteeringvalid = false;
            }
            else {
                $scope.lubeValidatae.IsSteeringvalid = true;
            }

            $scope.modal.show();
          
        }
        $ionicModal.fromTemplateUrl('modal.html', function(modal) {
            $scope.modal = modal;
        },
            {
                scope: $scope,
                // The animation we want to use for the modal entrance
                animation: 'slide-in-up'
            });

        $scope.hideLubeTips = function() {
            $scope.modal.hide();
        }

        $scope.lubesFilter = function(val) {
          
            var mkModal = val.make.concat(" ", val.model);
            
            if (!isEmpty($scope.mkMdlSearchString)) {
                var arr = $scope.mkMdlSearchString.split(/\s+/);
                for (i = 0; i < arr.length; i++) {
                    if (mkModal.toLowerCase().indexOf(arr[i].toLowerCase()) < 0) {
                        return false;
                    }
                }
                return true;
            }
            else {
                return true;
            }
        }
        function isEmpty(str) {
            return (!str || 0 === str.length);
        }
        $scope.goBack = function() 
        {   
            $ionicLoading.hide();
            var preView = userService.getpreviousView();
            $state.go(preView); 
        }
    })

    .controller('AirPressureController', function($scope, $state, $http, $ionicLoading, $timeout, $ionicPlatform, userService) {

        //Default two wheeler vechicles air pressures will be shown
        $scope.modalSearchString = "";
        $scope.selectedType = { name: "TWHEELER" };

        $ionicPlatform.ready(function() {
            $ionicLoading.show({
                template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Loading'
            });
            $http.get('https://xsparsh.indianoil.in:8443/soa-infra/resources/default/RDBFuel/RSTwPsi/', {}).success(function(data, status) {

                $scope.twFsis = data.FaiTwoWheeler;
                $ionicLoading.hide();
            }).error(onError);

            function onError(data) {
                alert(data);
                $ionicLoading.hide();
            }

            $ionicLoading.show({
                template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Loading'
            });
            $http.get('https://xsparsh.indianoil.in:8443/soa-infra/resources/default/RDBFuel/RSFwPsi/', {}).success(function(data, status) {

                $scope.fwFsis = data.FaiFourWheeler;
                $ionicLoading.hide();
            }).error(onError);

            function onError(data) {
                alert(data);
                $ionicLoading.hide();
            }

        });
        $scope.changeView = function(view) { $state.go(view); }
        $scope.goBack = function() 
        {   
            $ionicLoading.hide();
            var preView = userService.getpreviousView();
            $state.go(preView); 
        }
        $scope.onSelectChange = function() {
            //alert($scope.selectedType.name);
        }
        $scope.twFilter = function(val) {
            
            if (isEmpty($scope.modalSearchString) || val.motorcycle.toLowerCase().indexOf($scope.modalSearchString.toLowerCase()) >= 0) {
                return true;
            }
        }
        $scope.fwFilter = function(val) {
           
            if (isEmpty($scope.modalSearchString) || val.car.toLowerCase().indexOf($scope.modalSearchString.toLowerCase()) >= 0) {
                return true;
            }
        }
        function isEmpty(str) {
            return (!str || 0 === str.length);
        }
    })
    .controller('MydataController', function($scope, $location, $state, $ionicLoading, $timeout, $ionicPlatform, $ionicSlideBoxDelegate, userService) {
        $ionicPlatform.ready(function() {

        });
        
        $scope.changeView = function(view) {
            userService.setpreviousView("mydata");
            $state.go(view);
        }
        
        $scope.goBack = function() 
        {   
            $ionicLoading.hide();
            $state.go("app.home"); 
        }
    })
    .controller('ProfileController', function($scope, $state, $ionicLoading, $timeout, $ionicPlatform, $ionicModal, userService) {
      
        $scope.editStatus = {
            value: "",
            color: "blue"
        };
         
        var userMail = "";
       
        $ionicModal.fromTemplateUrl('modal.html', function(modal) {
            $scope.modal = modal;
        },
            {
                scope: $scope,
                // The animation we want to use for the modal entrance
                animation: 'slide-in-up'
            });

        $scope.showEdit = function() {
            $scope.editStatus.value = "";
            $scope.modal.show();
        }
        $scope.closeEdit = function() {
            $scope.modal.hide();
        }

        $scope.editProfile = function() {
            $ionicLoading.show({
                template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Updating Profile'
            });
            $scope.editStatus.value = "";
            validateData($scope.user,succesValidationCallback);
            function succesValidationCallback(result)
            {
                if(!result)
                {
                    userService.updateProfile($scope.user, editProfileCallBack);
                }
                else
                {
                    $scope.user.email = userMail;
                    $ionicLoading.hide();
                }
            }  
        }
        
        function editProfileCallBack(status) {

            if (status == "204") {
                $scope.editStatus.value = "Successfully Updated";
                $scope.editStatus.color = "blue";
            }
            else {
                $scope.editStatus.value = "Problem Occured";
                $scope.editStatus.color = "red";
            }
            $timeout(function() {
                $ionicLoading.hide();
            }, 1000);
        }

        function validateData(userData,succesValidationCallback)
        { 
                
                if(typeof userData.pinCode == "undefined")
                {
                    alert('Enter valid pincode');
                    succesValidationCallback(true);
                }
                else if(userData.pinCode!=null&&userData.pinCode.toString().length!=0&&userData.pinCode.toString().length!=6)
                {
                    alert('Pincode should be 6 digits');
                    succesValidationCallback(true);
                }
                else if(userMail!=userData.email){
                    userService.isUserExist(userData.email, 1212112121121211221).then(function(exists) {
                        if (exists) {
                            alert('Email ID is already registered. Please try different Email ID');
                            $ionicLoading.hide();
                            succesValidationCallback(true);
                        } else {
                            succesValidationCallback(false);
                        }
                    });  
                   
                }
                else{
                    succesValidationCallback(false);
                }
        }

        $scope.changeView = function(view) { $state.go(view); }
        
        $scope.goBack = function() 
        {   
            $ionicLoading.hide();
            var preView = userService.getpreviousView();
            $state.go(preView); 
        }
        
        $scope.$on('$ionicView.enter', function() {
          
          $scope.user = userService.getUser();
          userMail = $scope.user.email;
          
          if(JSON.stringify($scope.user.xtraReward).indexOf('@nil')>0)
          {
              $scope.user.xtraReward = "";
          }
          if(JSON.stringify($scope.user.address).indexOf('@nil')>0)
          {
              $scope.user.address = "";
          }
          if(JSON.stringify($scope.user.city).indexOf('@nil')>0)
          {
              $scope.user.city = "";
          }
          if(JSON.stringify($scope.user.pinCode).indexOf('@nil')>0)
          {
              $scope.user.pinCode = "";
          }
          if(JSON.stringify($scope.user.gender).indexOf('@nil')>0)
          {
              $scope.user.gender = "";
          }
        });

        
    })

    .controller('FeedBackController', function($scope, $state, $rootScope, $ionicPlatform, $ionicLoading, $http, $timeout, $ionicModal, userService) {

        $scope.FeedBackSelectd = null;
        $scope.FeedBacks = null;
        $scope.FeedBackDetails = null;
        $scope.error = "";
        $scope.isError = false;
        var user = null; 

        $ionicLoading.show({
            template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Loading'
        });

        function loadFeedBacks()
        {
            $scope.error = "";
            $scope.isError = false;
            $http.get('https://xsparsh.indianoil.in:8443/soa-infra/resources/default/RDBFuel/RSeCFSComplaintList/',
                {
                    params: {
                        mobileNo: user.mobile
                    }
                }).success(function(data, status) {
                    
                    //alert(JSON.stringify(data));
                    if (data && data.return) {
                        $scope.FeedBacks = data.return;
                    }
                    else {
                        $scope.error = "No FeedBack Posted";
                        $scope.isError = true;
                    }

                    $ionicLoading.hide();

                }).error(onError);

            function onError(data) {
                $ionicLoading.hide();
                $scope.error = "Error occured while retrieving feedbacks !!";
                $scope.isError = true;
            }
        }
        $scope.onFeedSelect = function(Feed) {
           $scope.FeedBackDetails = Feed;
           $scope.modal.show();
        }

        $ionicModal.fromTemplateUrl('modal.html', function(modal) {
            $scope.modal = modal;
        },
            {
                scope: $scope,
                // The animation we want to use for the modal entrance
                animation: 'slide-in-up'
            });

        $scope.hideFeedBacks = function() {
            $scope.modal.hide();
        }

        $scope.goBack = function() 
        {   
            $ionicLoading.hide();
            var preView = userService.getpreviousView();
            $state.go(preView); 
        }
        $scope.$on('$ionicView.enter', function() {
           user = userService.getUser();
           loadFeedBacks();
        });
    })

    .controller('VehicleController', function($scope, $state, $rootScope, $ionicPlatform, $ionicLoading, $http, $timeout, $ionicModal, userService, $cordovaDatePicker, $ionicPopup, $translate) {
        
        $scope.VehicleSelectd = null;
        $scope.Vehicles = null;
        $scope.error = "";
        $scope.isError = false;
        $scope.iSEditMode = false;
        var vhiclrRegNo = "";
        var user = userService.getUser();
        $scope.VehicleTypes = [];
        $scope.veclMkMdls = [];
        $scope.vechicle = {
            vehicleId: "",
            vehicleType: "-Select-",
            vehicleMake: "-Select-",
            vehicleModel: "",
            regNo: "",
            fuelType: "-Select-",
            fuelCapacity: "",
            puc: "",
            insurance: "",
            tax: ""
        };
   
        $scope.editStatus = { };
       

        $ionicPlatform.ready(function() {
            $http.get('https://xsparsh.indianoil.in:8443/soa-infra/resources/default/RDBFuel/RSVehicleMaster/',
                {
                    params: {}
                }).success(function(data, status) {

                    $scope.veclMkMdls = data.FaiVMkMd;
                    for (i = 0; i < $scope.veclMkMdls.length; i++) {
                        if ($scope.VehicleTypes.indexOf($scope.veclMkMdls[i].vehicleType) == -1) {
                            $scope.VehicleTypes.push($scope.veclMkMdls[i].vehicleType);
                        }
                    }
                    $scope.VehicleTypes.sort();
                    $ionicLoading.hide();
                }).error(onError);
        });

        function loadVehicles() {
            $http.get('https://xsparsh.indianoil.in:8443/soa-infra/resources/default/RDBFuel/RSUVList/',
                {
                    params: {
                        userID: user.userId
                    }
                }).success(function(data, status) {
                    if (data && data.FaiUserVehicle.length > 0) {
                        $scope.Vehicles = data.FaiUserVehicle;
                        for(i=0;i<$scope.Vehicles.length;i++)
                        {
                            if($scope.Vehicles[i].puc&&JSON.stringify($scope.Vehicles[i].puc).length>0&&JSON.stringify($scope.Vehicles[i].puc).indexOf('@nil')<0)
                            {
                                $scope.Vehicles[i].puc=JSON.stringify($scope.Vehicles[i].puc).substring(1,11);
                            }
                            else{
                                $scope.Vehicles[i].puc="";
                            }
                            if($scope.Vehicles[i].tax&&JSON.stringify($scope.Vehicles[i].tax).length>0&&JSON.stringify($scope.Vehicles[i].tax).indexOf('@nil')<0)
                            {
                                $scope.Vehicles[i].tax=JSON.stringify($scope.Vehicles[i].tax).substring(1,11);
                            }
                            else
                            {
                                $scope.Vehicles[i].tax="";
                            }
                            if($scope.Vehicles[i].insurance&&JSON.stringify($scope.Vehicles[i].insurance).length>0&&JSON.stringify($scope.Vehicles[i].insurance).indexOf('@nil')<0)
                            {
                                $scope.Vehicles[i].insurance=JSON.stringify($scope.Vehicles[i].insurance).substring(1,11);
                            }
                            else
                            {
                                $scope.Vehicles[i].insurance="";
                            }
                        }
                    }
                    else {
                        $scope.Vehicles = null;
                        $scope.error = "No Vehicle Added";
                        $scope.isError = true;
                    }


                }).error(onError);
        }

        function loadVclTypes() {
            
        }

        function onError(data) {
            $ionicLoading.hide();
            $scope.error = "Problem Occured While Retrieving Vehicles";
            $scope.isError = true;
        }


        $scope.mkMdlFilter = function(val) {
            if ($scope.vechicle.vehicleType == val.vehicleType) {
                return true;
            }
        }
        
        $scope.editMkMdlFilter = function(val) {
            if (val!=null && val.vehicleType!=null && $scope.VehicleSelectd.vehicleType == val.vehicleType) {
                return true;
            }
        }

        $ionicModal.fromTemplateUrl('modal.html', function(modal) {
            $scope.modal = modal;
        },
            {
                scope: $scope,
                // The animation we want to use for the modal entrance
                animation: 'slide-in-up'
            });

        $scope.onVehicleSelect = function(Vehicle) {
             $scope.iSEditMode = false;
             $scope.VehicleSelectd = Vehicle;
             vhiclrRegNo = $scope.VehicleSelectd.regNo;
             $scope.modal.show();

        }
        $scope.hideVehicles = function() {
            $scope.modal.hide();
        }



        $ionicModal.fromTemplateUrl('AddVecl.html', function(modal) {
            $scope.modalAddV = modal;
        },
            {
                scope: $scope,
                // The animation we want to use for the modal entrance
                animation: 'slide-in-up'
            });

        $scope.showAddVecl = function() {

            $scope.editStatus.value = "";
            $scope.vechicle = {
                vehicleId: "",
                vehicleType: "-Select-",
                vehicleMake: "-Select-",
                vehicleModel: "",
                regNo: "",
                fuelType: "-Select-",
                fuelCapacity: "",
                puc: "",
                insurance: "",
                tax: ""
            };
            $scope.modalAddV.show();
        }

        $scope.getVImage = function(vcle)
        {
            if(vcle)
            {
                if(vcle.vehicleType)
                {
                    if(vcle.vehicleType!='-Select-'&&JSON.stringify(vcle.vehicleType).indexOf('@nil')<0)
                    {
                        return vcle.vehicleType;
                    }
                    else
                    {
                        return 'FW';    
                    } 
                }
                else
                {
                    return 'FW';    
                }
            }
            else
            {
                return 'FW';    
            }
        }
        $scope.getValidVal = function(val)
        {
            
            if(val)
            {
                if(JSON.stringify(val).indexOf('@nil')>-1 || val=='-Select-')
                {
                  return "";
                }
                else{
                    return val;
                }
            }
            else
            {
                return "";
            }
            
        }

        $scope.createVehicle = function() {
            $ionicLoading.show({
                    template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
            });
            $scope.editStatus.value = "";
            var content = {
                FaiUserVehicle: [
                    {
                        userId: user.userId,
                        vehicleId: "",
                        vehicleType: $scope.vechicle.vehicleType,
                        vehicleMake: $scope.vechicle.vehicleMake,
                        vehicleModel: "",
                        regNo: $scope.vechicle.regNo.replace(/ /g,'').toUpperCase(),
                        fuelType: $scope.vechicle.fuelType,
                        fuelCapacity: $scope.vechicle.fuelCapacity,
                        puc: $scope.vechicle.puc,
                        insurance: $scope.vechicle.insurance,
                        tax: $scope.vechicle.tax
                    }
                ]

            };

           validateInputs($scope.vechicle,validateCallback);
           
           function validateCallback(rslt)
           {
               if (rslt) {
                   $http.post("https://xsparsh.indianoil.in:8443/soa-infra/resources/default/RDBFuel/RSUVAdd/", content)
                       .success(function(data, status) {
                           addVehicleCallBack(status);
                       }).error(function(data) {
                           $scope.editStatus.value = "Problem Occured";
                           $scope.editStatus.color = "red";
                       });
               }
               else {
                        $ionicLoading.hide();
               }
           }
            

            function addVehicleCallBack(status) {
                if (status == "204") {
                    loadVehicles();
                    alert("Successfully Added");
                    $scope.modalAddV.hide();
                }
                else {
                    $scope.editStatus.value = "Problem Occured";
                    $scope.editStatus.color = "red";
                }
                $timeout(function() {
                    $ionicLoading.hide();
                }, 1000);
            }

        }
        
        var options = {
                        date: new Date(),
                        mode: 'date', 
                        minDate: new Date()-10000,
                        allowOldDates: false,
                        allowFutureDates: true,
                        doneButtonLabel: 'DONE',
                        doneButtonColor: '#F2F3F4',
                        cancelButtonLabel: 'CANCEL',
                        cancelButtonColor: '#000000'
                    };
        $scope.showDatePicker = function(val)
        {
            if($cordovaDatePicker)
            {
                $cordovaDatePicker.show(options).then(function(date){
                    if(val=="PUC")
                    {
                        $scope.vechicle.puc = date;
                    }
                    else if(val=="INSURANCE")
                    {
                        $scope.vechicle.insurance = date;
                    }
                    else if(val=="TAX")
                    {
                        $scope.vechicle.tax = date;
                    }
                });
            }
        }
        function validateInputs(vehicle, validateCallback)
        {
            
            if (vehicle.regNo == null || vehicle.regNo < 1) {
                alert('Enter vehicle registration number');
                validateCallback(false);
            }
            else if(typeof vehicle.fuelCapacity == "undefined")
            {
                var reg = /^\d+$/;
                if(!reg.test(vehicle.fuelCapacity))
                {
                    alert('Fuel capacity should be integer.');
                    validateCallback(false);
                }
            }
            else if(vehicle.fuelCapacity == 0)
            {
                alert('Fuel capacity should not be 0.');
                validateCallback(false);
            }
            else if(vhiclrRegNo!=vehicle.regNo)
            {
                $http.get('https://xsparsh.indianoil.in:8443/soa-infra/resources/default/RDBXS/RSChkVeh/?vehNo='+vehicle.regNo.replace(/ /g,'').toUpperCase(),
                {
                    params: {}
                }).success(function(data, status) {
                    if(data!=null)
                    {
                        alert('Vehicle with registration number '+vehicle.regNo.replace(/ /g,'').toUpperCase()+' is already added.');
                        validateCallback(false);
                    }
                    else
                    {
                        validateCallback(true);
                    }
                }).error(function(){
                    alert('Problem occured while checking vehicle existency.');
                    validateCallback(false);
                });
                
            }
            else
            {
                validateCallback(true);
            }
            
           
        }
        
        $scope.isValid = function(val)
        {
            if(val)
            {
                return JSON.stringify(val).indexOf('@nil')<0 && JSON.stringify(val)!='-Select-';
            }
            else{
                return false;
            }   
        }
        
        $scope.showDatePickerE = function(val)
        {
            if($cordovaDatePicker)
            {
                $cordovaDatePicker.show(options).then(function(date){
                    if(val=="PUC")
                    {
                        $scope.VehicleSelectd.puc = date;
                    }
                    else if(val=="INSURANCE")
                    {
                        $scope.VehicleSelectd.insurance = date;
                    }
                    else if(val=="TAX")
                    {
                        $scope.VehicleSelectd.tax = date;
                    }
                });
            }
        }
        $scope.showEdit = function()
        {
            $scope.iSEditMode = true;
            $scope.error = "";
            $scope.editStatus.value = "";
            $scope.editStatus.color = "";
        }
        $scope.$on('$ionicView.enter', function() {
            vhiclrRegNo = "";
            loadVclTypes();
            user = userService.getUser();
            initiLiseValues();
            loadVehicles();
            
        });
        
        function initiLiseValues()
        {
            $scope.VehicleSelectd = null;
            $scope.error = "";
            $scope.isError = false;
            $scope.iSEditMode = false;
            $scope.editStatus = { };
        }
        $scope.updateVehicle = function()
        {
            $ionicLoading.show({
                    template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
            });
            $scope.editStatus.value = "";  
            var content = {
                FaiUserVehicle: [
                    {
                        userId: user.userId,
                        vehicleId: $scope.VehicleSelectd.vehicleId,
                        vehicleType: $scope.VehicleSelectd.vehicleType,
                        vehicleMake: $scope.VehicleSelectd.vehicleMake,
                        vehicleModel: "",
                        regNo: $scope.VehicleSelectd.regNo.replace(/ /g,'').toUpperCase(),
                        fuelType: $scope.VehicleSelectd.fuelType,
                        fuelCapacity: $scope.VehicleSelectd.fuelCapacity,
                        puc: $scope.VehicleSelectd.puc,
                        insurance: $scope.VehicleSelectd.insurance,
                        tax: $scope.VehicleSelectd.tax
                    }
                ]

            };

            validateInputs($scope.VehicleSelectd,validateEditCallback);
            
            function validateEditCallback(rslt)
           {
               if (rslt) {
                   $http.post("https://xsparsh.indianoil.in:8443/soa-infra/resources/default/RDBFuel/RSUVAdd/", content)
                .success(function(data, status) {
                    addVehicleCallBack(status);
                }).error(function(data) {
                    $scope.editStatus.value = "Problem Occured";
                    $scope.editStatus.color = "red";
                });
               }
               else {
                        $ionicLoading.hide();
               }
           }
            
            
            
            function addVehicleCallBack(status) {

                if (status == "204") {
                    $scope.editStatus.value = "Successfully Updated";
                    $scope.editStatus.color = "blue";
                    loadVehicles();
                }
                else {
                    $scope.editStatus.value = "Problem Occured";
                    $scope.editStatus.color = "red";
                }
                $timeout(function() {
                    $ionicLoading.hide();
                }, 1000);
            }     
        }
        $scope.deleteVehicle = function(vehicle)
        {
               var VehicleDeletion =$translate.instant('VEHICLEDELETION');
               var myPopup = $ionicPopup.show({
                                        template: '<span style="color:#10224d"><span translate="DOYOUWANTDELETEVEHICLE">Do you want to delete vehicle </span><span style="color: black;font-weight:bold">'+vehicle.regNo +'?</span></span>',
                                        title: '<span>'+VehicleDeletion+'</span>',
                                        scope: $scope,

                                        buttons: [
                                                    { text: 'Cancel',
                                                      type: 'button-assertive'
                                                    },
                                                    {
                                                        text: '<b>Delete</b>',
                                                        type: 'button-positive',
                                                        onTap: function(e) {
                                                            $http({
                                                                    "method": 'DELETE',
                                                                    "url": 'https://xsparsh.indianoil.in:8443/soa-infra/resources/default/RDBFuel/RSDelVehicle?vehicleId='+vehicle.vehicleId 
       
                                                                   }).success(function (data, status, headers, config) {
                                                                        alert('Successfullly Deleted');
                                                                        loadVehicles();
                                                                   }).error(function (data, status, headers, config) {
                                                                        alert('Error occured while deleting');
                                                                   });
                                                            
                                                       }
                                                  }
                                             ]
                                      });
               
        }
        
        $scope.goBack = function() 
        {   
            $ionicLoading.hide();
            var preView = userService.getpreviousView();
            $state.go(preView); 
        }
    })

    .controller('EBillController', function($scope, $state, $rootScope, $ionicPlatform, $ionicLoading, $http, $timeout, $ionicModal, userService, eBillService) {

        $scope.Bills = null;
        var user;
        
      
        function updateEbillls() {
            $ionicLoading.show({
                template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Loading'
            });
            eBillService.getEBills(user.userId, succss, onError);
        }
        function succss(data)
        {
            $scope.Bills = data;
            $ionicLoading.hide();
            $scope.$broadcast('scroll.refreshComplete');
        }
        function onError(data) {
            $ionicLoading.hide();
            $scope.error = data;
            $scope.$broadcast('scroll.refreshComplete');
        }
        
        $scope.$on('$ionicView.enter', function() {
           user = userService.getUser();
           updateEbillls();
        });

        $scope.refresh = function() {
            updateEbillls();
        }
        $scope.goBack = function() 
        {   
            $ionicLoading.hide();
            var preView = userService.getpreviousView();
            $state.go(preView); 
        }
    })

    .controller('XtrdsController', function($scope, $state, $rootScope, $ionicPlatform, $ionicLoading, $http, $timeout, $ionicModal, userService) {

        var user = userService.getUser();
       
        
        $scope.$on('$ionicView.enter', function() {
            $scope.isErrorOccured = false;
            $scope.SalsErns = [];
            $scope.Redeems = [];
            $scope.card = {
                CardNumber: parseInt(user.xtraReward),
                MobileNumber: parseInt(user.mobile),
                CardPin: "",
                RequestDateTime: "20150717153045"
            };
            /*$scope.card =  {						
	                    CardNumber : 5000160187,				
	                    CardPin : 4539,								
	                    RequestDateTime : "20150717153045",			
	                    MobileNumber : 9820982521				
                      };*/
            user = userService.getUser();
            $scope.cardDetails = null;
        });

        $ionicModal.fromTemplateUrl('modal.html', function(modal) {
            $scope.modal = modal;
        },
            {
                scope: $scope,
                // The animation we want to use for the modal entrance
                animation: 'slide-in-up'
            });

        $scope.showxtrdata = function() {
            $scope.modal.show();
        }
        $scope.hidextrdata = function() {
            $scope.modal.hide();
        }

        $scope.showRewardDetails = function() {
            if (validateXtrInputs()) {
                $scope.isErrorOccured = false;
                $scope.error = "";
                
                $ionicLoading.show({
                    template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Loading'
                });
                var request = $http({
                    method: "post",
                    url: "http://reports.xtrarewards.com/FuelMobileService/api/Transaction/CardBal",
                    headers: {
                        'Content-Type': 'application/json',
                        'Accept': 'application/json; charset=UTF-8'
                    },
                    data: $scope.card
                });
                request.success(
                    function(html) {

                        if (html.ResponseCode == "00") {
                            $scope.cardDetails = html;
                            getTransOfEarned(html.ResponseCode);
                            getRedeemsPoints(html.ResponseCode);
                            $scope.showxtrdata();
                            $ionicLoading.hide();
                        }
                        else {
                            $scope.isErrorOccured = true;
                            $scope.error = "No data found";
                            $ionicLoading.hide();
                        }

                    }
                ).error(Error);
            }
            {
                $scope.isErrorOccured = true;
            }

        }
        function validateXtrInputs() {
            if (!$scope.card.CardNumber || $scope.card.CardNumber.toString().length == 0) {
                $scope.error = 'Enter Valid Card number';
                return false;
            }

            if (!isEmpty($scope.card.MobileNumber)) {
                var a = $scope.card.MobileNumber.toString();
                if (a.length == 12) {

                    if (a.substring(0, 2) != "91") {
                        $scope.error = 'Enter Valid Mobile number';
                        return false;
                    }
                }
                else if (a.length != 10) {
                    $scope.error = 'Enter Valid Mobile number';
                    return false;
                }
            }
            else {
                $scope.error = 'Mobile number should not be empty';
                return false;
            }

            if (isEmpty($scope.card.CardPin)) {
                $scope.error = 'Enter Valid Pin number';
                return false;
            }

            return true;
        }
        function isEmpty(str) {
            return (!str || 0 === str.length);
        }

        function getTransOfEarned(ResponseCode) {

            
            if (ResponseCode == "00") {
                // Get All Earned Points
                var request = $http({
                    method: "post",
                    url: "http://reports.xtrarewards.com/FuelMobileService/api/Transaction/SalesTrans",
                    headers: {
                        'Content-Type': 'application/json',
                        'Accept': 'application/json; charset=UTF-8'
                    },
                    data: $scope.card
                });
                request.success(
                    function(html) {
                        if (html.ResponseCode == "00") {
                            for (i = 0; i < html.SalesTransDetails.length; i++) {
                                html.SalesTransDetails[i].TransactionDate = (html.SalesTransDetails[i].TransactionDate).replace(/^(\d{4})(\d{2})(\d{2})(\d{2})(\d{2})(\d{2})$/, "$3-$2-$1 $4:$5");
                            }
                            $scope.SalsErns = html.SalesTransDetails;
                            for(i=0;i<$scope.SalsErns.length;i++)
                            {
                                $scope.SalsErns[i].PointsEarned=parseFloat($scope.SalsErns[i].PointsEarned);
                                
                            }
                        }
                    }
                ).error(Error);

            }
        }

        function getRedeemsPoints(ResponseCode) {
            
            if (ResponseCode == "00") {
                // Get All Earned Points
                var request = $http({
                    method: "post",
                    url: "http://reports.xtrarewards.com/FuelMobileService/api/Transaction/RedeemTrans",
                    headers: {
                        'Content-Type': 'application/json',
                        'Accept': 'application/json; charset=UTF-8'
                    },
                    data: $scope.card
                });
                request.success(
                    function(html) {
                        if (html.ResponseCode == "00") {
                            for (i = 0; i < html.RedeemTransDetails.length; i++) {
                                html.RedeemTransDetails[i].TransactionDate = (html.RedeemTransDetails[i].TransactionDate).replace(/^(\d{4})(\d{2})(\d{2})(\d{2})(\d{2})(\d{2})$/, "$3-$2-$1 $4:$5");
                            }
                            $scope.Redeems = html.RedeemTransDetails;
                            for(i=0;i<$scope.SalsErns.length;i++)
                            {
                                $scope.Redeems[i].PointsRedeemed=parseFloat($scope.Redeems[i].PointsRedeemed);
                                
                            }
                        }
                    }
                ).error(Error);
            }
        }
        function Error(data) {
            //alert('The error is ' + JSON.stringify(data));
            $ionicLoading.hide();
            $scope.isErrorOccured = true;
            $scope.error = "There was some problem while retrieving data. Inconvenience caused is regretted.";
        }
        $scope.goBack = function() 
        {   
            $ionicLoading.hide();
            var preView = userService.getpreviousView();
            $state.go(preView); 
        }
    })
    .controller('ResetPController', function($scope, $state, $rootScope, $ionicPlatform, $ionicLoading, $http, $timeout, $ionicModal, userService) {
        $scope.goBack = function() {
            $ionicLoading.hide();
            $state.go('login');
        }
    })
    .controller('GnrlFbController', function($scope, $state, $rootScope, $ionicPlatform, $ionicLoading,  $ionicPopup, $http, $timeout, $ionicModal, userService) {
        $scope.fb = {
            category: "",
            subCategory: "",
            description: "",
        };
        $scope.FeedbackResult = "";
        $scope.isFbPOver= false;
        
        $scope.$on('$ionicView.enter', function() {
            $scope.FeedbackResult = "";
            $scope.fb = {
                category: "Feedback",
                subCategory: "Application",
                description: "",
            };
            $scope.isFbPOver= false;
        });
        var user = userService.getUser();

        $scope.postGFb = function() {
            
            if($scope.fb.description==null || $scope.fb.description.length<=0)
            {
                alert('Give valid feedback');
            }
            else
            {
                $ionicLoading.show({
                    template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
                });
                var request = $http({
                method: "post",
                url: "https://xsparsh.indianoil.in:8443/soa-infra/resources/default/RDBFuel/RSFeedback",
                headers: {
                    'Content-Type': 'application/json; charset=UTF-8',
                    'Accept': 'application/json'
                },
                data: {
                    "FaiFdComp": [
                        {
                            "roCode": "",
                            "userId": user.mobile,
                            "category": $scope.fb.category,
                            "subCategory": $scope.fb.subCategory,
                            "description": $scope.fb.description
                        }
                    ]
                }

               });
               request.success(
                function(html) {
                    $ionicLoading.hide();
                    $scope.FeedbackResult = "Thank you for your valuable feedback";
                    $ionicLoading.hide();
                    $scope.isFbPOver = true;
                    var msg = "";
                    
                    if($scope.fb.subCategory == "Application")
                    {
                        msg = 'Dear ' + user.name + ', Thanks for your valuable feedback on Fuel@IOC." This will be useful in further improving our mobile app. We thank you for patronising  Fuel@IOC App."' 
                    }
                    else{
                       msg = 'Dear ' + user.name + ', Thanks for your valuable feedback .This will be useful in improving our services. We thank you for patronising  "Fuel@IOC."';
                    }
                    /*
                    var content = {
                        "mobile_no": user.mobile,
                        "sms_content": msg,
                        "sms_type": "ENG",
                        "userID": "WEBS",
                        "password": "WEBS@USER765"
                    };

                    $http.post("https://xsparsh.indianoil.in:8443/soa-infra/resources/default/RDBFuel/RSSendSMS/", content)
                        .success(function(data, status) {
                        });
                        
                     */
                    var content =
                        {
                            "mobile_no": user.mobile,
                            "sms_text": msg,
                            "user_id": "FUEL@IOC",
                            "password": "FUEL@IOC123",
                            "app_name": "GeneralFeedback_FuelAIOC",   /// Swachh, OTP, feedback etc.
                            "dealer_code": 0 /// pass 0 if not available in case of OTP, general feedback etc.
                        };


                    $http.post("https://xsparsh.indianoil.in:8443/soa-infra/resources/default/RDBFuel/RSSendSMSv2/", content)
                        .success(function(data, status) {
                        });

                }
              ).error(feedbkError);
            }
            
            
        }
        function feedbkError(error)
        {
            $scope.FeedbackResult = "Problem occured while processing";
            $ionicLoading.hide();
            $scope.isFbPOver= true;
        }
        $scope.goBack = function() 
        {   
            $ionicLoading.hide();
            $state.go("app.home"); 
        }
        $scope.checkComplaint = function()
        {
           
            if($scope.fb.category=="Complaint")
            { 
                var myPopup = $ionicPopup.show({
                    template: 'Please Choose Retail Outlet For Complaint',
                    title: 'Grievance',
                    scope: $scope,
                    buttons: [
                        { text: 'Cancel',
                            type: 'button-assertive'
                        },
                        {
                            text: '<b>OK</b>',
                            type: 'button-positive',
                            onTap: function(e) {
                                userService.setpreviousView("feedbackus");
                                userService.setMapView("Complaint");
                                //checkLocation('map');
                                $state.go('map');
                            }
                        }
                    ]
                });
            }
            else if($scope.fb.category=="Rating")
            {
                var myPopup = $ionicPopup.show({
                    template: 'Please Choose Retail Outlet For Rating Submission',
                    title: 'Rating',
                    scope: $scope,
                    buttons: [
                        { text: 'Cancel',
                            type: 'button-assertive'
                        },
                        {
                            text: '<b>OK</b>',
                            type: 'button-positive',
                            onTap: function(e) {
                                userService.setpreviousView("feedbackus");
                                userService.setMapView("Rating");
                                $state.go('map');
                            }
                        }
                    ]
                });
            }
        }
        function checkLocation(view)
        {
            var posOptions = {
                                            enableHighAccuracy: true,
                                            timeout: 15000,
                                            maximumAge: 0
                                         };
                        $cordovaGeolocation.getCurrentPosition(posOptions).then(function(position) {
                
                                $state.go(view);
                        },
                        function(error) {
                            var errMsg="";
                            switch(error.code) {
                                case error.PERMISSION_DENIED:
                                    errMsg = "User denied the request for Geolocation."
                                    break;
                                case error.POSITION_UNAVAILABLE:
                                    errMsg = "Location information is unavailable."
                                    break;
                                case error.TIMEOUT:
                                    errMsg = "The request to get user location timed out."
                                    break;
                                case error.UNKNOWN_ERROR:
                                    errMsg = "An unknown error occurred."
                                    break;
                            }
                            //alert(errMsg);
                            $ionicLoading.hide();
                       });
        }
    })
    .controller('NWLostController', function($scope, $state, $rootScope,  $cordovaNetwork) {
    
            $scope.checkNeConnectivity = function()
            {
                if($cordovaNetwork.isOnline())
                {
                    $state.go('login');
                }
            }
    
    })
    .controller('OffersController', function($scope, $state, $rootScope,  $cordovaNetwork, userService, $ionicLoading, $http, $ionicPopup) {
    
        $scope.goBack = function() 
        {   
            $ionicLoading.hide();
            var preView = userService.getpreviousView();
           
            $state.go(preView); 
        }
        
        $scope.sbtCshReceipt = function() {
            $scope.rsltMsg = "";
            if ($scope.receiptData.text == ""  || ($scope.receiptData.text && $scope.receiptData.text.length == 0)) {
                $scope.rsltMsg = "Please enter Cash Receipt Number";
                alert($scope.rsltMsg);
            }
            else if(typeof $scope.receiptData.text==undefined || $scope.receiptData.text == null)
            {
                alert('Dear Xtrapremium Customer, Bill No. entered by you is empty or not in correct format. Re-enter cash receipt numner. For help call 18002676700 Toll free');
            }
            else {
                var text = "ioc " + $scope.receiptData.text;
                var url = 'http://121.241.244.238:9501/voiceapi/api_obd_ioc.php?account=IOCLXTRA&pin=G7$2Jwr(f&msisdn=' + $scope.user.mobile + '&ibd_campid=127&text=' + text + '&vmn=9220066666';
                var requestRate = $http.get(url);

                $ionicLoading.show({
                    template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
                });

                requestRate.success(
                    function(html) {
                        if (html == "SUCCESS") {
                            $scope.rsltMsg = "Your bill number is registered successfully.";
                            var myPopup = $ionicPopup.show({
                                template: $scope.rsltMsg ,
                                title: '<span>Message</span>',
                                scope: $scope,

                                buttons: [

                                    {
                                        text: '<b>OK</b>',
                                        type: 'button-positive',
                                        onTap: function(e) {
                                            $scope.goBack();
                                        }
                                    }
                                ]
                            });
                        }
                        else if (html == "DUPLICATE") {
                            $scope.rsltMsg = "Your bill number is already registered.";
                            var myPopup = $ionicPopup.show({
                                template: $scope.rsltMsg ,
                                title: '<span>Message</span>',
                                scope: $scope,

                                buttons: [

                                    {
                                        text: '<b>OK</b>',
                                        type: 'button-positive',
                                        onTap: function(e) {
                                            $scope.goBack();
                                        }
                                    }
                                ]
                            });
                        }
                        else {
                            $scope.rsltMsg = "Problem occured while processing.";
                        }
                        $ionicLoading.hide();
                    }
                ).error(function(html) {
                    $scope.rsltMsg = "Problem occured while processing. Try again";
                    alert($scope.rsltMsg);
                    $ionicLoading.hide();
                });
            }
        }
        $scope.$on('$ionicView.enter', function() {
            $scope.rsltMsg = "";
            $scope.user = userService.getUser();
            $scope.receiptData = {
                text:""
            }
        });
    })
    .controller('RatingController', function($scope, $state, $http, eBillService, $ionicLoading,  userService, $ionicPlatform, $timeout) {
    
        var ratingRo = {
            rating_PQ: 0,
            rating_QD: 0,
            rating_S: 0,
            rating_CL: 0,
            rating_F: 0,
            rating_CT: 0
        };
        $scope.isRateSubmit = false;
        $scope.ratingStatus = "";
        var user = userService.getUser();
        $scope.rating_PQ_Object = {
            iconOn: 'ion-ios-star',
            iconOff: 'ion-ios-star-outline',
            iconOnColor: 'rgb(1, 87, 155)',
            iconOffColor: 'rgb(1, 87, 155)',
            rating: 0,
            minRating: 0,
            readOnly: false,
            callback: function(rating) {
                ratingRo.rating_PQ = rating;
            }
          };
          $scope.rating_QD_Object = {
            iconOn: 'ion-ios-star',
            iconOff: 'ion-ios-star-outline',
            iconOnColor: 'rgb(1, 87, 155)',
            iconOffColor: 'rgb(1, 87, 155)',
            rating: 0,
            minRating: 0,
            readOnly: false,
            callback: function(rating) {
                ratingRo.rating_QD = rating;
            }
          };
          $scope.rating_S_Object = {
            iconOn: 'ion-ios-star',
            iconOff: 'ion-ios-star-outline',
            iconOnColor: 'rgb(1, 87, 155)',
            iconOffColor: 'rgb(1, 87, 155)',
            rating: 0,
            minRating: 0,
            readOnly: false,
            callback: function(rating) {
                ratingRo.rating_S = rating;
            }
          };
          $scope.rating_CL_Object = {
            iconOn: 'ion-ios-star',
            iconOff: 'ion-ios-star-outline',
            iconOnColor: 'rgb(1, 87, 155)',
            iconOffColor: 'rgb(1, 87, 155)',
            rating: 0,
            minRating: 0,
            readOnly: false,
            callback: function(rating) {
                ratingRo.rating_CL = rating;
            }
          };
          $scope.rating_F_Object = {
            iconOn: 'ion-ios-star',
            iconOff: 'ion-ios-star-outline',
            iconOnColor: 'rgb(1, 87, 155)',
            iconOffColor: 'rgb(1, 87, 155)',
            rating: 0,
            minRating: 0,
            readOnly: false,
            callback: function(rating) {
                ratingRo.rating_F = rating;
            }
          };
          $scope.rating_CT_Object = {
            iconOn: 'ion-ios-star',
            iconOff: 'ion-ios-star-outline',
            iconOnColor: 'rgb(1, 87, 155)',
            iconOffColor: 'rgb(1, 87, 155)',
            rating: 0,
            minRating: 0,
            readOnly: false,
            callback: function(rating) {
                ratingRo.rating_CT = rating;
            }
         };
        
        var latestEbill = null;
        
        
        $scope.postRoRating = function()
        {
            if (ratingRo.rating_PQ != 0 && ratingRo.rating_QD != 0 && ratingRo.rating_S && ratingRo.rating_CL != 0 && ratingRo.rating_F != 0 && ratingRo.rating_CT != 0) 
            {
                $ionicLoading.show({
                    template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Posting rating!'
                });
                var content = {
                                  FaiFeedbackRating:
                                  {
                                        roCode: latestEbill.DEALER_CODE,
                                        productQuality: ratingRo.rating_PQ,
                                        quantityDelivered: ratingRo.rating_QD,
                                        service: ratingRo.rating_S,
                                        facilities: ratingRo.rating_CL,
                                        cleaniness: ratingRo.rating_F,
                                        cleantoilet: ratingRo.rating_CT,
                                        userId: user.mobile,
                                        txnid: latestEbill.TXN_ID,
                                        roAtdId: "0",
                                        feedbackFrom: "FUELAIOC",
                                        remarks: $scope.remarks.content
                                   }
                               };
                           
                var request = $http.post('https://xsparsh.indianoil.in:8443/soa-infra/resources/default/RDBXS/RSFBRating/ ', content);

                request.success(
                    function(html) {
                        
                        var paramsVal = {
                            dealerCode: latestEbill.DEALER_CODE,
                        	isRated: ratingRo.rating_PQ,
                            txnId:latestEbill.TXN_ID
                        };
                        
                     
                        var requestRate = $http.put('https://xsparsh.indianoil.in:8443/soa-infra/resources/default/RDBFuel/RSUpdateTxn/', null, {
                            params: paramsVal
                        });
                        
                        requestRate.success(
                               function(html) {
                                   $scope.ratingStatus = 'Thank you for your valuable rating.';
                                   $scope.isRateSubmit = true;
                                   $ionicLoading.hide();
                                  
                                   

                                   var getRtdRos = userService.getRtdRos();
                                   var isFound = false;
                                   for (k = 0; k < getRtdRos.length; k++) {
                                       if (getRtdRos[k].ro_code == parseInt(latestEbill.DEALER_CODE)) {
                                           isFound = true;
                                       }
                                   }
                                   if (!isFound) {
                                       
                                       if (ratingRo.rating_PQ >= 3 && ratingRo.rating_QD >= 3 && ratingRo.rating_S >= 3 && ratingRo.rating_CL >= 3 && ratingRo.rating_F >= 3 && ratingRo.rating_CT >= 3) {
                                           sendFormatedSms(user.name, latestEbill.CUST_NAME, user.mobile, latestEbill.DEALER_CODE,  "1");
                                       }
                                       else {
                                           sendFormatedSms(user.name, latestEbill.CUST_NAME, user.mobile, latestEbill.DEALER_CODE, "-1");
                                       }
                                       userService.populateRtdRos(user.mobile);
                                   }

                                   $timeout(function() {
                                       $state.go('app.home');
                                   }, 1000);
                            }
                        ).error(ratingError);   
                    }
                ).error(ratingError);
           }
           else {
                alert('Please rate all categories');
           }
        }
        
        function sendFormatedSms(userName, dealerName, mobile, rocode, val)
        {
            $http.get("https://xsparsh.indianoil.in:8443/soa-infra/resources/default/Notifications/RSFbSMS?app_name=FUELAIOC")
                .success(function(data, status) {
                    var msg;
                    if(data.FaiRatingSms[0].msgType == val)
                    {
                        msg = data.FaiRatingSms[0].msgText;
                    }
                    else{
                        msg = data.FaiRatingSms[1].msgText;
                    }
                    msg = msg.replace("$username$", userName);
                    msg = msg.replace("$roname$", dealerName);
                    

                    var content =
                                       {
                                           "mobile_no": mobile,
                                           "sms_text": msg,
                                           "user_id": "FUEL@IOC",
                                           "password": "FUEL@IOC123",
                                           "app_name": "Rating_FuelAIOC",   /// Swachh, OTP, feedback etc.
                                           "dealer_code": rocode /// pass 0 if not available in case of OTP, general feedback etc.
                                       };

                    $http.post("https://xsparsh.indianoil.in:8443/soa-infra/resources/default/RDBFuel/RSSendSMSv2/", content)
                        .success(function(data, status) {

                        }).error(function() {
                            console.log("Error in sending SMS");
                        });

                }).error(function() {
                    console.log("Error in sending SMS");
                });
        }
        
        
        function ratingError(data)
        {
            $scope.ratingStatus = 'Error Occured While Submitting Rating.';
            $scope.isRateSubmit = false;
            $ionicLoading.hide();
        }
        
        $scope.$on('$ionicView.enter', function() {
            ratingRo = {
              rating_PQ: 0,
              rating_QD: 0,
              rating_S: 0,
              rating_CL: 0,
              rating_F: 0,
              rating_CT: 0
          };
            $scope.remarks = {
                content:""
            };
            $scope.rating_PQ_Object.reset();
            $scope.rating_QD_Object.reset();
            $scope.rating_S_Object.reset();
            $scope.rating_CL_Object.reset();
            $scope.rating_F_Object.reset();
            $scope.rating_CT_Object.reset();
            user = userService.getUser();
            $scope.ratingStatus = '';
            $scope.isRateSubmit = false;
            latestEbill = eBillService.Ebills()[0];
        });
       
    })
    .controller('VersionController',function($scope, $state)
    {
        $scope.updateVersion = function()
        {
             window.open('https://play.google.com/store/apps/details?id=com.iocl.maps', '_system', 'location=no');
        }
    })
    .controller('SBharatController', function($scope, $timeout, $http, $state, $rootScope,  $cordovaNetwork, userService, $ionicLoading, $cordovaCamera, ecfsService, $ionicPopup, $ionicModal) {
 
        $scope.goBack = function() {
            var preView = userService.getpreviousView();
            $state.go(preView);
        }
        
        $scope.isError = false;
        $scope.rsltMsg = "";
        $scope.roFound = false;
        
        $scope.previewData = "";
        
        

        //Modal window for filter
        $ionicModal.fromTemplateUrl('photoPreview.html', function(modal) {
            $scope.modal = modal;
        },
            {
                scope: $scope,
                // The animation we want to use for the modal entrance
                animation: 'slide-in-up'
            });

        
        $scope.showPreview = function(val)
        {
            $ionicLoading.show({
                    template: '<ion-spinner icon="bubbles"></ion-spinner><br/>'
            });
            $timeout(function() {
                    $ionicLoading.hide();
             }, 2000);
            $scope.previewData = val;
            $scope.modal.show();
        }
        $scope.closePreview = function()
        {
            $scope.modal.hide()
        }
        
        
        $scope.takePicture = function () {
            $ionicLoading.show({
                    template: '<ion-spinner icon="bubbles"></ion-spinner><br/>'
            });
            var options = {
                quality: 40,
                destinationType: Camera.DestinationType.DATA_URL,
                sourceType: Camera.PictureSourceType.CAMERA,
                allowEdit: true,
                encodingType: Camera.EncodingType.PNG,
                targetWidth: 100,
                targetHeight: 100,
                popoverOptions: new CameraPopoverOptions(300, 300, 100, 100, Camera.PopoverArrowDirection.ARROW_ANY),
                saveToPhotoAlbum: false,
                correctOrientation: true
            };

            $cordovaCamera.getPicture(options).then(function (imageData) {
                
                
                $timeout(function() {
                    $ionicLoading.hide();
                }, 2000);
                var imgData = {
                                fileBytes :imageData,
                                fileName : "file"+$scope.imageCount+".png"
                               };
               
                
                $scope.images[$scope.imageCount]=imgData;
               
                
                $scope.imageCount++;
            }, function (err) {
                
                 $ionicLoading.hide();
            });
        }
        $scope.getPicture = function()
        {
            $ionicLoading.show({
                    template: '<ion-spinner icon="bubbles"></ion-spinner><br/>'
            });
            var options = {
                quality: 40,
                destinationType: Camera.DestinationType.DATA_URL,
                sourceType: Camera.PictureSourceType.SAVEDPHOTOALBUM,
                allowEdit: true,
                encodingType: Camera.EncodingType.PNG,
                targetWidth: 100,
                targetHeight: 100,
                popoverOptions: CameraPopoverOptions,
                saveToPhotoAlbum: false,
                correctOrientation: true
            };

            $cordovaCamera.getPicture(options).then(function (imageData) {
                
                $timeout(function() {
                    $ionicLoading.hide();
                }, 2000);
                var imgData = {
                                fileBytes :imageData,
                                fileName : "file"+$scope.imageCount+".png"
                               };
               
                
                $scope.images[$scope.imageCount]=imgData;
                
                $scope.imageCount++;
               
            }, function (err) {
                //alert('The error is'+JSON.stringify(err));
                 $ionicLoading.hide();
            });
        }
        
        $scope.deletImage = function(index)
        {
          
            
            $ionicLoading.show({
                   template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Removing!'
            });
            $scope.images.splice(index,1);
            $scope.imageCount = $scope.imageCount - 1; 
            $timeout(function() {
                $ionicLoading.hide();
            }, 1000);
         
        }
        
        
        $scope.getRoDetails = function() {
            if(typeof $scope.userData.rocode == 'undefined')
            {
                $scope.isError = true;
                $scope.rsltMsg = "Entered Dealer code is invalid or empty";
                alert($scope.rsltMsg);
                return;
            }
            if($scope.userData.rocode.length == 0)
            {
                 $scope.isError = true;
                 $scope.rsltMsg = "Entered Dealer code is invalid or empty";
                 return;
            }
            if ($scope.userData.rocode.length >= 6) {
                $ionicLoading.show({
                   template: '<ion-spinner icon="bubbles"></ion-spinner><br/>'
                });
                $http.get("https://xsparsh.indianoil.in:8443/soa-infra/resources/default/RDBXS/RSRoData/?ro_code=" + $scope.userData.rocode)
                    .success(function(data) {
                        if (data) {
                            $scope.roDetails = data.VwMobCustomer[0];
                            $scope.roFound = true;
                            $scope.isError = false;
                        }
                        else{
                            $scope.roDetails = "";
                            $scope.roFound = false;
                            $scope.isError = true;
                            $scope.rsltMsg = "Entered Dealer code is invalid";
                            alert($scope.rsltMsg);
                        }
                        $ionicLoading.hide();
                    });
            }
            else
            {
                $scope.isError = true;
                $scope.roFound = false;    
                $scope.rsltMsg = "Entered Dealer code is invalid";
                alert($scope.rsltMsg);
            }
        }
        
        
        $scope.postComplaint = function () {
           
           
           
           if($scope.user.gender!="M" && $scope.user.gender!="F")
           {
               $scope.user.gender = "M";
           }
           
           if($scope.imageCount==0)
           {
               var imgData = {
                                fileBytes :"",
                                fileName : ""
                               };
               
                
                $scope.images[$scope.imageCount]=imgData;
           }
           
           
           
           if($scope.userData.rocode=="")
           {
               $scope.isError = true;
               $scope.rsltMsg = "Entered Dealer code is invalid or empty";
               alert($scope.rsltMsg);
               return;
           }
           else
           {
               $scope.isError = false;
           }
           
           if(!$scope.roFound)
           {
               alert($scope.rsltMsg);
               return;
           }
           else
           {
                $scope.isError = false;
           }
           
           if ($scope.userData.choice) {
               switch ($scope.userData.choice) {
                   case 1:
                       $scope.userData.choiceDesc = "Toilet Clean"
                       break;
                   case 2:
                       $scope.userData.choiceDesc = "Toilet Not Clean"
                       break;
                   case 3:
                       $scope.userData.choiceDesc = "Toilet Not Available/Toilet locked"
                       break;
               }
               $scope.isError = false;
           }
           else
           {
               $scope.isError = true;
               $scope.rsltMsg = "Select FEEDBACK";
               alert($scope.rsltMsg);
               return;
           }

           if (!$scope.isError) {

               $ionicLoading.show({
                   template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Posting feedback!'
               });

               if ($scope.userData.choice == 1) {

                   $scope.stsComplaint = "Thank You for your feedback.";
                   var msg = "Thank You for your feedback. We appreciate your acknowledgement of clean Toilet under Swachh Bharat Abhiyan initiative. It will motivate us to serve you better.";

                   //Ol url
                   //https://xsparsh.indianoil.in:8443/soa-infra/resources/default/RDBFuel/RSSendSMS/

                   /*
                   //Old content
                    var content={
                                              "mobile_no" : $scope.user.mobile,
                                              "sms_content" : msg,
                                              "sms_type" : "ENG",
                                              "userID" : "WEBS",
                                              "password" : "WEBS@USER765"
                              };
                   */

                   var content =
                       {
                           "mobile_no": $scope.user.mobile,
                           "sms_text": msg,
                           "user_id": "FUEL@IOC",
                           "password": "FUEL@IOC123",
                           "app_name": "Swachh_FuelAIOC",   /// Swachh, OTP, feedback etc.
                           "dealer_code": $scope.userData.rocode /// pass 0 if not available in case of OTP, general feedback etc.
                       };


                   $http.post("https://xsparsh.indianoil.in:8443/soa-infra/resources/default/RDBFuel/RSSendSMSv2/", content)
                       .success(function(data, status) {
                       });

                   var myPopup = $ionicPopup.show({
                       template: $scope.stsComplaint,
                       title: '<span>Message</span>',
                       scope: $scope,

                       buttons: [

                           {
                               text: '<b>OK</b>',
                               type: 'button-positive',
                               onTap: function(e) {
                                   $scope.goBack();
                               }
                           }
                       ]
                   });

                   $scope.isResultOver = true;
                   $ionicLoading.hide();
               }
               else {
                   var dataAfterRmHashVals = angular.copy($scope.images);
                   ecfsService.postComplaint(dataAfterRmHashVals, $scope.userData, $scope.user).then(function(response) {
                       $scope.stsComplaint = response;

                       $scope.isResultOver = true;


                       var myPopup = $ionicPopup.show({
                           template: $scope.stsComplaint,
                           title: '<span>Message</span>',
                           scope: $scope,

                           buttons: [

                               {
                                   text: '<b>OK</b>',
                                   type: 'button-positive',
                                   onTap: function(e) {

                                       $scope.goBack();
                                   }
                               }
                           ]
                       });

                       $ionicLoading.hide();
                   });
               }

           }
           else {
               alert($scope.rsltMsg);
               $ionicLoading.hide();
           }     
        }
        
        $scope.resetComplaint = function()
        {
            $scope.isResultOver = false;
            $scope.imageCount = 0;
            $scope.images = [];
            $scope.userData = {
                rocode: "",
                name: $scope.user.name,
                choice: 0,
                mobile: $scope.user.mobile,
                choiceDesc: ""
            };
            $scope.isError = false;
            $scope.rsltMsg = "";
            $scope.roFound = false;
            $scope.stsComplaint = "";
        }
        
        $scope.$on('$ionicView.enter', function() {
            $scope.user = userService.getUser();
            $scope.isResultOver = false;
            $scope.imageCount = 0;
            $scope.images = [];
            $scope.isError = false;
            $scope.rsltMsg = "";
            $scope.roFound = false;
            $scope.previewData = "";
            $scope.userData = {
                rocode: "",
                name: $scope.user.name,
                choice: 0,
                mobile: $scope.user.mobile,
                choiceDesc: ""
            };
            $scope.stsComplaint = "";
        });

    })
    .controller('PrebookController',function($scope, $timeout, $cordovaInAppBrowser, $cordovaBarcodeScanner,$http, $state, $rootScope,  $cordovaNetwork, userService, $ionicLoading, $cordovaCamera, $ionicPopup, $ionicModal)
    {
       

            var permissions = cordova.plugins.permissions;
            permissions.hasPermission(permissions.CAMERA, checkPermissionCallback, null);
            
            function checkPermissionCallback(status) {
            if(!status.hasPermission) {
                var errorCallback = function() {
                console.warn('Camera permission is not turned on');
                }
            
                permissions.requestPermission(
                permissions.CAMERA,
                function(status) {
                    if(!status.hasPermission) errorCallback();
                },
                errorCallback);
            }
            }

            $scope.channels = true;

            $scope.scan = function(){
                
                   $cordovaBarcodeScanner.scan().then(function(imageData) {
                      //  alert(imageData.text);
                        if(imageData.text!=null || imageData.text!=""){

                              $rootScope.roForPayment = imageData.text;
                              $scope.roDetails.roCode = imageData.text;
                             $scope.getRoDetails();
                              userService.setFromMapViewPay(true);
                              $scope.isRowValid = true;

                        }else{

                            alert("Try Again !!");
                        }

                        console.log("Barcode Format -> " + imageData.text);
                        console.log("Cancelled -> " + imageData.cancelled);
                    }, function(error) {
                        console.log("An error happened -> " + error);
                    });


 };


       


        $scope.products = [
            {
                Name : "Petrol",
                val : "ms",
                checked : false,
                available : false,
                price : 0
            },
            {
                Name : "Diesel",
                val : "hsd",
                checked : false,
                available : false,
                price : 0
            }
        ];
        
        $scope.roDetails ={
            roCode :""
        }
        
        $scope.$on('$ionicView.enter', function() {
            
            
          $scope.vehicleRegNo = "";
          $scope.roDetails.roCode = "";
          $scope.user = userService.getUser();
          $scope.products[0].checked = false;
          $scope.products[1].checked = false;
          
          if(userService.getFromMapViewPay())
          {
              
              userService.setFromMapViewPay(false);
              $scope.selectedRo = $rootScope.roForPayment;
              $scope.roDetails.roCode = $scope.selectedRo.rocode;
            
              
             if($scope.selectedRo.ms && JSON.stringify($scope.selectedRo.ms).indexOf("@nil")<0)
             {
                 $scope.products[0].available = true;
                 $scope.products[0].price = parseFloat($scope.selectedRo.ms);
             }
             if($scope.selectedRo.hsd && JSON.stringify($scope.selectedRo.hsd).indexOf("@nil")<0)
             {
                 $scope.products[1].available = true;
                 $scope.products[1].price = parseFloat($scope.selectedRo.hsd);
             }
            
             $scope.isRowValid = true;
              
          }
          else
          {
              $scope.roDetails.roCode = "";
              $scope.amt = "";
              $scope.isRowValid = false;
          }
          
          
        });
        
        $scope.showVehicles = function() {
            
            $scope.modalName.show();
            loadVehicles();
        }
        
        $scope.hideVehicles = function() {
            
            $scope.modalName.hide();
        }
        
        //Modal Window For RO related 
        $ionicModal.fromTemplateUrl('vehicleModal.html', function(modal) {
            $scope.modalName = modal;
        },
            {
                scope: $scope,
                // The animation we want to use for the modal entrance
                animation: 'slide-in-right'
            });

      $scope.selectProduct = function(product)
      {
          
              if($scope.amt)
              {
                if($scope.products[0].checked)  //if ms got selected
                {
                    $scope.apxVal = ($scope.amt / ($scope.products[0].price)).toFixed(2);
                }
                else if($scope.products[1].checked)      //if hsd got selected
                {
                    $scope.apxVal = ($scope.amt / ($scope.products[1].price)).toFixed(2);
                }
              }
      }
      
      $scope.selectVehicle = function(vehicle)
      {
          $scope.vehicleRegNo = vehicle.regNo;
          $scope.modalName.hide();
      }
        
        
      $scope.browseRo = function()
      {
          userService.setMapView("RoSelection");
          userService.setpreviousView("Prebook");
          $ionicLoading.show({
                   template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Loading'
          });
           $timeout(function() {
               $ionicLoading.hide();
           }, 2000);
          $state.go("map");
      }
       

      $scope.calAprox = function(amount) {
          $scope.amt = amount;
          if ($scope.amt) {
              if ($scope.products[0].checked)  //if ms got selected
              {
                  $scope.apxVal = ($scope.amt / ($scope.products[0].price)).toFixed(2);
              }
              else if ($scope.products[1].checked)      //if hsd got selected
              {
                  $scope.apxVal = ($scope.amt / ($scope.products[1].price)).toFixed(2);
              }
          }
         
      };




       function onError(data) {
            $ionicLoading.hide();
            $scope.error = "Problem Occured While Retrieving Vehicles";
            $scope.isError = true;
        }


      
      $scope.getRoDetails = function()
      {   
          $scope.products[0].checked = false;
          $scope.products[1].checked = false;
          $scope.apxVal = 0;
                    
            $scope.PaymentChannel = {

                channels : ""
            };


            $http.get('https://xsparsh.indianoil.in:8443/soa-infra/resources/default/Payments/RSRoMerchant/',
                {
                    params: {
                        ro_code: $scope.roDetails.roCode
                    }
                }).success(function(data, status) {
                    if (data && data.FaiMerchantDetails.length > 0) {
                        $scope.PaymentChannel = data.FaiMerchantDetails;

                        if($scope.PaymentChannel.length>0){

                             //   alert("Payment Channel Found !!");

                                if($scope.roDetails.roCode.length == 6)
          {
              $ionicLoading.show({
                   template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Loading'
              });
              var url = "https://m.indianoil.in:8443/sap/opu/odata/sap/Z_XS_CUST_SP_new_SRV/ZMACUSTRSPSet?$filter=Soldto%20eq%20%27"+$scope.roDetails.roCode+"%27%20&$format=json";
              $http.get(url)
                    .success(function(data) {

                            if(data==null || data=="")alert("error");

                        if (data && data.d && data.d.results && data.d.results.length > 0) {
                            $scope.isRowValid = true;
                            for (var i = 0; i < data.d.results.length; i++) {

                                if (data.d.results[i].Matname.toLowerCase().indexOf("ms") >= 0) {
                                    $scope.products[0].available = true;
                                    $scope.products[0].price = parseFloat(data.d.results[i].Rsp);
                                    
                                }
                                else if (data.d.results[i].Matname.toLowerCase().indexOf("hsd") >= 0) {
                                    $scope.products[1].available = true;
                                    $scope.products[1].price = parseFloat(data.d.results[i].Rsp);
                                }
                               

                            }
                            $ionicLoading.hide();
                            $scope.channels = true;
                        }
                        else {

                            alert('Entered Dealer code is invalid');
                            $scope.channels = false;
                            $scope.isRowValid = true;
                            $ionicLoading.hide();
                        }
                    }).error(function(data) {
                        
                        $ionicLoading.hide();
                         alert('Entered Dealer code is invalid');
                    });
          }
          else
          {
              alert('Please Enter Valid Dealer Code');
          }


                        }else{

                            alert("No Payment Channel Found");
                            $scope.channels = false;
                        }
                        for(i=0;i<$scope.PaymentChannel.length;i++)
                        {
                            $scope.PaymentChannel[i].channels = data.FaiMerchantDetails[i].merchantName;

                        }
                    }
                    else {
                        $scope.Payments = null;
                        $scope.error = "No Transactions Found !!";
                        $scope.isError = true;
                    }


                }).error(onError);


                                                      

          
      };
      
      $scope.changePr = function(pr)
      {
          if (pr.val == "ms" && $scope.products[0].checked) {
              $scope.products[1].checked = false;
          }
          else if (pr.val == "hsd" && $scope.products[1].checked) {
              $scope.products[0].checked = false;
          }
          else
          {
              $scope.apxVal = 0;
          }
          
          // If amount got filled
          if ($scope.amt) {
              if ($scope.products[0].checked)  //if ms got selected
              {
                  $scope.apxVal = ($scope.amt / ($scope.products[0].price)).toFixed(2);
              }
              else if ($scope.products[1].checked)      //if hsd got selected
              {
                  $scope.apxVal = ($scope.amt / ($scope.products[1].price)).toFixed(2);
              }
          }
      }
      function loadVehicles() {
            $ionicLoading.show({
                   template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Loading'
              });
            $http.get('https://xsparsh.indianoil.in:8443/soa-infra/resources/default/RDBFuel/RSUVList/',
                {
                    params: {
                        userID: $scope.user.userId
                    }
                }).success(function(data, status) {
                    if (data && data.FaiUserVehicle.length > 0) {
                        $scope.Vehicles = data.FaiUserVehicle;
                        for(i=0;i<$scope.Vehicles.length;i++)
                        {
                            if($scope.Vehicles[i].puc&&JSON.stringify($scope.Vehicles[i].puc).length>0&&JSON.stringify($scope.Vehicles[i].puc).indexOf('@nil')<0)
                            {
                                $scope.Vehicles[i].puc=JSON.stringify($scope.Vehicles[i].puc).substring(1,11);
                            }
                            else{
                                $scope.Vehicles[i].puc="";
                            }
                            if($scope.Vehicles[i].tax&&JSON.stringify($scope.Vehicles[i].tax).length>0&&JSON.stringify($scope.Vehicles[i].tax).indexOf('@nil')<0)
                            {
                                $scope.Vehicles[i].tax=JSON.stringify($scope.Vehicles[i].tax).substring(1,11);
                            }
                            else
                            {
                                $scope.Vehicles[i].tax="";
                            }
                            if($scope.Vehicles[i].insurance&&JSON.stringify($scope.Vehicles[i].insurance).length>0&&JSON.stringify($scope.Vehicles[i].insurance).indexOf('@nil')<0)
                            {
                                $scope.Vehicles[i].insurance=JSON.stringify($scope.Vehicles[i].insurance).substring(1,11);
                            }
                            else
                            {
                                $scope.Vehicles[i].insurance="";
                            }
                        }
                        $ionicLoading.hide();
                    }
                    else {
                        $ionicLoading.hide();
                        $scope.Vehicles = null;
                       
                    }


                }).error(function(){
                    $ionicLoading.hide();
                });
        }


        $scope.payment = function(){

            var  userid = window.localStorage.getItem('username');
            var amount = $scope.amt;
            var roCode = $scope.roDetails.roCode;

                var options = {
                    location: 'no',
                    clearcache: 'yes',
                    toolbar: 'no'
                };


                    console.log("m here");
                    $cordovaInAppBrowser.open('https://xsparsh.indianoil.in:8443/SBIbuddy/PayNow?roCode='+roCode+'&userID='+userid+'&amount='+amount, '_self', options)
                        .then(function (event) {
                            // success
                        })
                        .catch(function (event) {
                            // error
                        });
            



        };


      

        $rootScope.$on('$cordovaInAppBrowser:loadstart', function (e, event) {

        });

        $rootScope.$on('$cordovaInAppBrowser:loadstop', function (e, event) {
            // insert CSS via code / file

            
            if (event.url.match("https://xsparsh.indianoil.in:8443/SBIbuddy/callback")) {
                console.log("m here");
               $cordovaInAppBrowser.close();
               $state.go('Transactions');
            }


        });






        $scope.goBack = function() 
        {
            $scope.vehicleRegNo = "";
            $scope.roDetails.roCode = "";
            $scope.products[0].checked = false;
            $scope.products[1].checked = false;

            $ionicLoading.hide();
            var preView = userService.getpreviousView();

            $state.go(preView);
        }
      
    })

    .controller('TransactionsController',function($scope, $timeout,  $cordovaBarcodeScanner,$http, $state, $rootScope,  $cordovaNetwork, userService, $ionicLoading, $cordovaCamera, $ionicPopup, $ionicModal)
    {
       
            $scope.refresh = function() {
            updateTransactions();
             }



             $scope.$on('$ionicView.enter', function() {
            
            

              $scope.Payments = {
                tid: "",
                merchant : "",
                roCode : "",
                userId : "",
                orderId : "",
                amount : "",
                createdAt : "",
                status : "",
                statusText : "",
                transactionId : "",
                logo: "",
                tran_status:""
            };

           

          updateTransactions();
          
        });
           
        
        function updateTransactions(){

            var userid = window.localStorage.getItem('username');

              $http.get('https://xsparsh.indianoil.in:8443/soa-infra/resources/default/Payments/RSFuelPayments/',
                {
                    params: {
                        mobile: userid
                    }
                }).success(function(data, status) {
                    if (data && data.FaiPayment.length > 0) {
                        $scope.Payments = data.FaiPayment;
                        for(i=0;i<$scope.Payments.length;i++)
                        {
                            
                            $scope.Payments[i].tid = data.FaiPayment[i].tid;
                            $scope.Payments[i].merchant = data.FaiPayment[i].merchant;
                            $scope.Payments[i].roCode = data.FaiPayment[i].roCode;
                            $scope.Payments[i].userId = data.FaiPayment[i].userId;
                            $scope.Payments[i].orderId = data.FaiPayment[i].orderId;
                            $scope.Payments[i].amount = data.FaiPayment[i].amount;
                             
                             var dd = new Date(data.FaiPayment[i].createdAt);
                             var tt = dd.toString().substring(0, 25);
                            $scope.Payments[i].createdAt = tt;


                            $scope.Payments[i].status = data.FaiPayment[i].status;
                            $scope.Payments[i].statusText = data.FaiPayment[i].statusText;
                            $scope.Payments[i].transactionId = data.FaiPayment[i].transactionId;

                            if((data.FaiPayment[i].merchant).includes("SBIBuddy")){

                            $scope.Payments[i].logo = "sbi";


                            }else if((data.FaiPayment[i].merchant).includes("PayTM")){

                            $scope.Payments[i].logo = "paytm";

                            }



                            if((data.FaiPayment[i].status)=="1"){

                            $scope.Payments[i].tran_status = "success";


                            }else{

                            $scope.Payments[i].tran_status = "failure";

                            }

                            $scope.$broadcast('scroll.refreshComplete');

                        }
                    }
                    else {
                        $scope.Payments = null;
                        $scope.error = "No Transactions Found !!";
                        $scope.isError = true;
                    }


                }).error(onError);

        }

        
       function onError(data) {
            $ionicLoading.hide();
            $scope.error = "Problem Occured While Retrieving Vehicles";
            $scope.isError = true;
        }

        $scope.PaymentDetails = "";

        $scope.showDetails = function(pay){

        $scope.PaymentDetails = pay;
             
        $ionicModal.fromTemplateUrl('transactions.html', function(modal) {
        
        $scope.modal = modal;
        },
            {
                scope: $scope,
                // The animation we want to use for the modal entrance
                animation: 'slide-in-up'
            });


           
        $scope.modal.show();
        
        }
          
        $scope.goBack = function() 
        {      
            $ionicLoading.hide();
            $state.go('app.home');
        }


    });
    
